﻿Public Class CHashTable
  Private Const MAX_TABLE = 128
  Private MaxCols As Integer
  Private ColCountArr() As Integer
  Private NameMat(,) As String
  Private IndexMat(,) As Integer

  Public Sub New()
    Dim I As Integer

    MaxCols = 0
    ReDim ColCountArr(MAX_TABLE)
    ReDim NameMat(MAX_TABLE, 1)
    ReDim IndexMat(MAX_TABLE, 1)
  End Sub

  Private Sub GetMaxColsCount()
    Dim I As Integer

    MaxCols = 0
    For I = 1 To MAX_TABLE
      If MaxCols < ColCountArr(I) Then
        MaxCols = ColCountArr(I)
      End If
    Next
  End Sub

  Private Function CalcHashVal(ByVal sName As String) As Integer
    Const SHIFT = 47
    Dim I, Len As Integer
    Dim Sum As Long = 0
    Dim Pwr2 As Long = 1

    sName = sName.ToUpper
    Len = sName.Length
    For I = Len - 1 To 0 Step -1
      Sum += (Asc(sName.Chars(I)) - SHIFT) * Pwr2
      Pwr2 *= 2
    Next
    Return 1 + Sum Mod MAX_TABLE
  End Function

  Public Sub Insert(ByVal sName As String, ByVal nIndex As Integer)
    Dim HashIndex, nCols As Integer

    If FindEx(sName, HashIndex) < 1 Then
      ColCountArr(HashIndex) += 1
      nCols = ColCountArr(HashIndex)
      If nCols > MaxCols Then
        MaxCols = nCols
        ReDim Preserve NameMat(MAX_TABLE, MaxCols)
        ReDim Preserve IndexMat(MAX_TABLE, MaxCols)
      End If
      NameMat(HashIndex, nCols) = sName.ToUpper
      IndexMat(HashIndex, nCols) = nIndex
    End If
  End Sub

  Public Function Find(ByVal sName As String) As Integer
    Dim I, HashIndex As Integer

    sName = sName.ToUpper
    HashIndex = CalcHashVal(sName)
    If ColCountArr(HashIndex) > 0 Then
      For I = 1 To ColCountArr(HashIndex)
        If sName = NameMat(HashIndex, I) Then
          Return IndexMat(HashIndex, I)
        End If
      Next
    End If
    Return 0
  End Function

  Public Function FindEx(ByVal sName As String, ByRef HashIndex As Integer) As Integer
    Dim I As Integer

    sName = sName.ToUpper
    HashIndex = CalcHashVal(sName)
    If ColCountArr(HashIndex) > 0 Then
      For I = 1 To ColCountArr(HashIndex)
        If sName = NameMat(HashIndex, I) Then
          Return IndexMat(HashIndex, I)
        End If
      Next
    End If
    Return 0
  End Function

  Public Sub Delete(ByVal sName As String)
    Dim I, J, HashIndex As Integer

    sName = sName.ToUpper
    HashIndex = CalcHashVal(sName)
    If ColCountArr(HashIndex) > 0 Then
      For I = 1 To ColCountArr(HashIndex)
        If sName = NameMat(HashIndex, I) Then
          If I < ColCountArr(HashIndex) Then
            For J = I To ColCountArr(HashIndex) - 1
              IndexMat(HashIndex, J) = IndexMat(HashIndex, J + 1)
              NameMat(HashIndex, J) = NameMat(HashIndex, J + 1)
            Next
            ColCountArr(HashIndex) -= 1
          End If
        End If
      Next
    End If
  End Sub

End Class
