﻿Imports System.IO
Imports System.Console
Imports System.Math
' The above two Imports elimitate the need to use COnsole. and Math. with console I/O and math function calls.

Module Module1

  Sub Main()
    Const MAX_LINES_VIEWED As Integer = 20
    Dim objRpnCalc As RPNCalc
    Dim objPrgRpnCalc As ProgRPNCalc
    Dim sRPN, SelLbl, frmt, sPrgm As String
    Dim sPath, sFileExt As String
    Dim sFilename As String = ""
    Dim Count As Integer = 0
    Dim ISel, MaxMenu, I, J, numLines As Integer
    Dim X As Double
    Dim aLine, SourceLines() As String
    Dim bRanProgram As Boolean = False

    objRpnCalc = New RPNCalc()
    WriteLine("-------------------- RPN Emulator -------------------- ")
    WriteLine("Version {0}. Created {1}", objRpnCalc.GetVersion, objRpnCalc.GetDateCreated)
    WriteLine("Last update on {0}", objRpnCalc.GetLastUpdated)
    WriteLine(objRpnCalc.GetCopyright)
    WriteLine("------------------------------------------------------")
    WriteLine()
    Do
      WriteLine("")
      WriteLine("------------------- MAIN MENU ----------------------")
      WriteLine("0) Exit.")
      WriteLine("1) Use calculator mode.")
      WriteLine("2) Use Filename query mode.")
      WriteLine("3) View/Edit source code of a CPRCA program.")
      WriteLine("4) Run a program.")
      If bRanProgram AndAlso My.Computer.FileSystem.FileExists(sFilename) Then
        I = sFilename.LastIndexOf("\")
        If I >= 0 Then
          sPrgm = sFilename.Substring(I + 1)
        Else
          sPrgm = sFilename
        End If
        WriteLine("5) Rerun program " & sPrgm & ".")
        WriteLine("6) View/Edit program " & sPrgm & ".")
        MaxMenu = 6
      Else
        MaxMenu = 4
      End If
      WriteLine("------------------------------------------------------")
      Write("Select menu option by number: ")
      If Integer.TryParse(ReadLine, ISel) Then
        If ISel > -1 And ISel <= MaxMenu Then
          Select Case ISel
            Case 0
              ' do nothing
            Case 1
              Do
                WriteLine("Enter an RPN Expression (or press Enter to exit calculator mode)")
                sRPN = ReadLine()
                If sRPN.Trim().Length = 0 Then Exit Do
                X = objRpnCalc.Calc(sRPN)
                frmt = objRpnCalc.GetFormat()
                WriteLine(objRpnCalc.Output(X))
              Loop
            Case 2
              Write("Enter path to search (press Enter to select the current directory): ")
              sPath = ReadLine()
              If sPath.Trim() = "" Then sPath = "."
              Write("Enter (just the) file extention: ")
              sFileExt = ReadLine()
              ' remove the * and/or dot that the user maye have entered
              If sFileExt.StartsWith("*") Then sFileExt = sFileExt.Substring(1)
              If sFileExt.StartsWith(".") Then sFileExt = sFileExt.Substring(1)
              If sFileExt.Trim() = "" Then sFileExt = "*"

              Try
                For Each foundfile As String In Directory.GetFiles(sPath, "*." & sFileExt)
                  WriteLine(foundfile)
                  Count += 1
                  If Count > 10 Then
                    Count = 0
                    Write("Press Enter to continue viewing the file list ...")
                    ReadLine()
                  End If
                Next
              Catch
                WriteLine("Error! Invalid file path.")
              End Try
            Case 3, 6
              If ISel = 3 Then
                Write("Enter program filename: ")
                sFilename = ReadLine().Trim
              End If

              If (Not My.Computer.FileSystem.FileExists(sFilename)) And
                  My.Computer.FileSystem.FileExists(sFilename & ".txt") Then
                sFilename &= ".txt"
              End If

              If My.Computer.FileSystem.FileExists(sFilename) Then
                Shell("notepad.exe " & sFilename, AppWinStyle.NormalFocus)
              Else
                WriteLine("File {0} does not exit! Please check the path and/or the filename spelling.", sFilename)
              End If

            Case 4
              WriteLine("Enter program filename")
              sFilename = ReadLine().Trim

              If (Not My.Computer.FileSystem.FileExists(sFilename)) And
                  My.Computer.FileSystem.FileExists(sFilename & ".txt") Then
                sFilename &= ".txt"
              End If

              If My.Computer.FileSystem.FileExists(sFilename) Then
                objPrgRpnCalc = New ProgRPNCalc(sFilename)
                If objPrgRpnCalc.CanExecute Then
                  WriteLine("Program " & sFilename & " has been loaded into memory.")
                  WriteLine("Your 'character' input options for launching or ending the programs are:")
                  WriteLine("Press Enter to start at the first lbl or enter ? to view and select labels or enter ! to abort program executio: ")
                  SelLbl = ReadLine()
                  If SelLbl = "!" Then
                    ' do nothing
                  ElseIf SelLbl = "?" Then ' show labels
                    objPrgRpnCalc.ExecProgramByLabelNumber()
                  ElseIf SelLbl.Trim().Length = 0 Then ' start at the top
                    objPrgRpnCalc.ExecProgram("")
                  Else
                    objPrgRpnCalc.ExecProgram(SelLbl)
                  End If
                  bRanProgram = True
                End If ' objPrgRpnCalc.CanExecute
              Else
                  WriteLine("File " & sRPN & " does not exist or its path is incorret.")
              End If
            Case 5
              objPrgRpnCalc = New ProgRPNCalc(sFilename)
              WriteLine("Program " & sFilename & " has been reloaded into memory.")
              WriteLine("Your 'character' input options for launching or ending the programs are:")
              WriteLine("Press Enter to start at the first lbl or enter ? to view and select labels or enter ! to abort program executio: ")
              SelLbl = ReadLine()
              If SelLbl = "!" Then
                ' do nothing
              ElseIf SelLbl = "?" Then ' show labels
                objPrgRpnCalc.ExecProgramByLabelNumber()
              ElseIf SelLbl.Trim().Length = 0 Then ' start at the top
                objPrgRpnCalc.ExecProgram("")
              Else
                objPrgRpnCalc.ExecProgram(SelLbl)
              End If

            Case Else
          End Select
        Else
          WriteLine("Invalid menu number.")
        End If
      Else
        WriteLine("Invalid input")
      End If

    Loop Until ISel = 0
  End Sub


End Module
