﻿Imports System.IO
Imports System.Console
Imports System.Math
' The above two Imports elimitate the need to use Console. and Math. with console I/O and math function calls.


Public Class RPNCalc

  Private Const COPYRIGHT = "Copyright 2015, 2016 (c) Namir Clement Shammas"
  Private Const VERSION = "1.1.0"
  Private Const DATE_CREATED = "November 13, 2015"
  Private Const DATE_UPDATED = "March 10, 2016"
  Protected Const HIGHEST_VAL As Double = Double.MaxValue
  Protected Const HIGH_VAL As Double = Double.MaxValue / 10
  Protected Const BIG_VAL As Double = 1.0E+99
  Protected Const SCALE As Long = 10000
  Protected Const SCALE41 As Long = 1000
  Protected Const X_STACK_REG = 1
  Protected Const Y_STACK_REG = 2
  Protected Const Z_STACK_REG = 3
  Protected Const T_STACK_REG = 4
  Private Const STACK_SIZE As Integer = 4
  Protected Const MAX_MEM As Integer = 9999
  Protected Stack(STACK_SIZE) As Double
  Protected LastStack(STACK_SIZE) As Double
  Private Mem(MAX_MEM) As Double
  Protected bErr As Boolean
  Protected sErrMessage As String
  Protected StatCount, SumX, SumX2, SumY, SumY2, SumXY As Double
  Protected MeanX, MeanY, SdevX, SdevY As Double
  Protected Slope, Intercept, R2 As Double
  Protected Reg_SS, Total_SS, Residual_SS, S As Double
  Protected Residual_df As Integer
  Protected bHaveRegressionResults As Boolean
  Protected sCat As String
  Protected DisplayFormat As String
  Private Gln As Double

  Public Sub New()
    Dim I As Integer

    For I = 1 To STACK_SIZE
      Stack(I) = 0
    Next
    For I = 1 To MAX_MEM
      Mem(I) = 0
    Next
    fxClearSigma()
    bErr = False
    sErrMessage = ""
    DisplayFormat = ""
    sCat = "+,-,*,/,^,"
    sCat &= "SCALE,SCALE41,CLX,CHS,STO,STO+,STO-,STO*,STO/,"
    sCat &= "STOIND,STOIND+,STOIND-,STOIND*,STOIND/,"
    sCat &= "STOSTINDX,STOSTINDY,STOSTINDZ,STOSTINDT,"
    sCat &= "STOSTINDX+,STOSTINDX-,STOSTINDX*,STOSTINDX/,"
    sCat &= "STOSTINDY+,STOSTINDY-,STOSTINDY*,STOSTINDY/,"
    sCat &= "STOSTINDZ+,STOSTINDZ-,STOSTINDZ*,STOSTINDZ/,"
    sCat &= "STOSTINDT+,STOSTINDT-,STOSTINDT*,STOSTINDT/,"
    sCat &= "STOSTX,STOSTY,STOSTZ,STOSTT,"
    sCat &= "STOSTX+,STOSTX-,STOSTX*,STOSTX/,"
    sCat &= "STOSTY+,STOSTY-,STOSTY*,STOSTY/,"
    sCat &= "STOSTZ+,STOSTZ-,STOSTZ*,STOSTZ/,"
    sCat &= "STOSTT+,STOSTT-,STOSTT*,STOSTT/,"
    sCat &= "RCLSTINDX,RCLSTINDY,RCLSTINDZ,RCLSTINDT,"
    sCat &= "RCLSTX,RCLSTY,RCLSTZ,RCLSTT,"
    sCat &= "RCL,RCL+,RCL-,RCL*,RCL/,"
    sCat &= "RCLIND,RCLIND+,RCLIND-,RCLIND*,RCLIND/,"
    sCat &= "LASTX,LASTY,LASTZ,LASTT,ENTER,PI,+,-,*,/,MOD,Y^X,X<>Y,X<>Z,X<>T,Y<>Z,Y<>T,Z<>T,"
    sCat &= "RDN,RUP,CLST,CLSTK,CLRSTK,CLREG,CLREGX,ABS,LN,LOG,EXP,10^,1/X,X^2,SQRT,"
    sCat &= "SIN,COS,TAN,SIND,COSD,TAND,ASIN,ACOS,ATAN,ASIND,ACOSD,ATAND,"
    sCat &= "SINH,COSH,TANH,ASINH,ACOSH,ATANH,LNGAMMA,LNFACT,EULER,SUMPWR,SUMNEGPWR,SUMPWRTOL,SUMNEGPWRTOL,SIGN,"
    sCat &= "INT,FRAC,FRC,FACT,IFACT,RAND,RANDNORM,PERM,COMB,MEANSDEV,"
    sCat &= "CLEARSIGMA,SIGMA+,S+,SIGMA-,S-,S++,SIGMA++,MEAN,SDEV,LRXY,"
    sCat &= "GAMMA,BETA,MEMCOPY,MEMSWAP,BESSELJ0,BESSELJ1,BESSELJN,BESSELY0,BESSELY1,BESSELYN,IGAMMA,IIGAMMA,"
    sCat &= "CHEBYSHEV,HERMITE,LEGENDRE,LAGUERRE,NEXTPRIME,LASTPRIME,FIB,ZETA,ZETA2,"
    sCat &= "R->P,P->R,D->R,R->D,->HMS,HMS->,HMS+,HMS-,"
    sCat &= "ERF,ERFC,IERF,IERFC,EXPOINTEG,SI,CI,YHAT,XHAT,COPYRIGHT,VERSION,GETMAXMEM,"
    sCat &= "SUMN,SUMX,SUMX2,SUMY,SUMY2,SUMXY,INVQ,INVT,INVF,INVCHI,"
    sCat &= "Q_CDF,T_CDF,CHI_CDF,F_CDF,INVQ_CDF,INVT_CDF,INVCHI_CDF,INVF_CDF,"
    sCat &= "Q_PDF,T_PDF,CHI_PDF,False,Q_STD,"
    sCat &= "CISLOPE,CIINTERCEPT,CIYHAT,CIYHATFIT,CIR2,CIRSQR,CIR,CIMEANX,CIMEANY,CISDEVX,CISDEVY,"
    sCat &= "-STK-,VIEWSTK,SHOWSTK,DSP,FIX,SCI,CLRDSP,"
    sCat &= "GETDATE,GETTIME,GETYEAR,GETMONTH,GETDAY,GETHR,GETMIN,GETSEC,"
    sCat &= "MFILL,MFILLRND,MFILLINTRND,MFILLNORMRND,MFILLSEQ,COPYSTACK"
    sCat = "," & sCat.ToUpper.Trim() & ","

  End Sub

  Public Function GetCopyright() As String
    Return COPYRIGHT
  End Function

  Public Function GetVersion() As String
    Return VERSION
  End Function

  Public Function GetDateCreated() As String
    Return DATE_CREATED
  End Function

  Public Function GetLastUpdated() As String
    Return DATE_UPDATED
  End Function

  Public Function GetDateUpdated() As String
    Return DATE_UPDATED
  End Function

  Protected Sub fxMFill(ByVal X As Double, ByVal Range As Decimal)
    Dim First As Integer = 0
    Dim Last As Integer = MAX_MEM
    Dim Inc As Integer = 1

    If Range > 0 Then
      First = Fix(Range)
      Range = SCALE * (Range - First)
      Last = Fix(Range)
      Range = 100 * (Range - Last)
      Inc = Max(1, Fix(Range))
    End If

    For I = First To Last Step Inc
      Mem(I) = X
    Next
  End Sub

  Protected Sub fxMFillRand(ByVal Low As Double, ByVal High As Double, ByVal Range As Decimal)
    Dim First As Integer = 0
    Dim Last As Integer = MAX_MEM
    Dim Inc As Integer = 1

    If Range > 0 Then
      First = Fix(Range)
      Range = SCALE * (Range - First)
      Last = Fix(Range)
      Range = 100 * (Range - Last)
      Inc = Max(1, Fix(Range))
    End If

    For I = First To Last Step Inc
      Mem(I) = Low + (High - Low) * Rnd(1)
    Next
  End Sub

  Protected Sub fxMFillRandInt(ByVal Low As Integer, ByVal High As Integer, ByVal Range As Decimal)
    Dim First As Integer = 0
    Dim Last As Integer = MAX_MEM
    Dim Inc As Integer = 1

    If Range > 0 Then
      First = Fix(Range)
      Range = SCALE * (Range - First)
      Last = Fix(Range)
      Range = 100 * (Range - Last)
      Inc = Max(1, Fix(Range))
    End If

    For I = First To Last Step Inc
      Mem(I) = Low + Fix((High - Low) * Rnd(1))
    Next
  End Sub

  Protected Sub fxMFillNormRand(ByVal Mean As Double, ByVal Sdev As Double, ByVal Range As Decimal)
    Dim First As Integer = 0
    Dim Last As Integer = MAX_MEM
    Dim Inc As Integer = 1

    If Range > 0 Then
      First = Fix(Range)
      Range = SCALE * (Range - First)
      Last = Fix(Range)
      Range = 100 * (Range - Last)
      Inc = Max(1, Fix(Range))
    End If

    For I = First To Last Step Inc
      Mem(I) = RandomNormal(Mean, Sdev)
    Next
  End Sub

  Protected Sub fxMFillSeq(ByVal InitVal As Double, ByVal IncVal As Double, ByVal Range As Decimal)
    Dim First As Integer = 0
    Dim Last As Integer = MAX_MEM
    Dim Inc As Integer = 1

    If Range > 0 Then
      First = Fix(Range)
      Range = SCALE * (Range - First)
      Last = Fix(Range)
      Range = 100 * (Range - Last)
      Inc = Max(1, Fix(Range))
    End If

    For I = First To Last Step Inc
      Mem(I) = InitVal
      InitVal += IncVal
    Next
  End Sub


  Public Sub SetFormat(ByVal s As String)
    Const MAX_DIGITS As Integer = 15
    Const FRMT_CHARSET As String = "EFDPDXG"
    Dim c As String
    Dim I As Long

    s = s.Trim
    c = s.Substring(0, 1).ToUpper
    If FRMT_CHARSET.IndexOf(c) >= 0 Then
      ' check number after the format designator
      If s.Length > 1 Then
        I = CLng(s.Substring(1))
        If I > MAX_DIGITS Then I = MAX_DIGITS
        ' redo the format string
        s = s.Substring(0, 1) & CStr(I)
      End If
      DisplayFormat = s
    End If
  End Sub

  Public Function GetFormat() As String
    Return DisplayFormat
  End Function

  Public Function GetDisplayFormatPrefix(ByVal Optional sFormat As String = "") As String
    Dim sResult As String = ""

    If sFormat.Length = 0 Then sFormat = DisplayFormat
    If sFormat.Length > 0 AndAlso sFormat.Substring(0, 1).ToUpper = "X" Then
      Return "x"
    End If
    Return ""
  End Function

  Public Function Output(ByVal X As Double, ByVal Optional sFormat As String = "")
    Dim C As String
    Dim I As Long

    ' convert Nan into a large number
    If X = Double.NaN Then X = BIG_VAL

    If sFormat.Length = 0 Then sFormat = DisplayFormat

    ' is DisplayFormat itself a non-empyt string?
    If sFormat.Length > 0 Then
      C = sFormat.Substring(0, 1).ToUpper
      Try
        If C <> "X" AndAlso C <> "D" Then
          Return X.ToString(sFormat)
        Else
          I = CLng(X)
          Try
            Return GetDisplayFormatPrefix(C) & I.ToString(sFormat)
          Catch
            ' try with just "X", "D", "x", or "d"
            Try
              Return GetDisplayFormatPrefix(C) & I.ToString(sFormat.Substring(0, 1))
            Catch
              Return CStr(I) ' Last resort for "X" or "D" formats
            End Try
          End Try
        End If
      Catch
        Return CStr(X) ' last resort for non-"X" and non-"D" formats
      End Try
    Else
      ' both sFormat and DisplayFormat are empty string
      Return CStr(X)
    End If
  End Function

  Protected Function ParseInt(ByVal s As String) As Integer
    Dim I As Integer

    If Double.TryParse(s, I) Then
      Return I
    Else
      sErrMessage = "Error in converting '" & s & "' into an integer. Conversion is set to 0"
      Return 0
    End If
  End Function

  Protected Function ParseDbl(ByVal s As String) As Double
    Dim X As Double

    If Double.TryParse(s, X) Then
      Return X
    Else
      sErrMessage = "Error in converting '" & s & "' into an a real value. Conversion is set to 1"
      Return 1
    End If
  End Function

  Protected Function GetDate() As Double
    Dim iYear, iMonth, iDay As Integer
    Dim dt As Date = Now()
    Dim X As Double

    iYear = Year(dt)
    iMonth = Month(dt)
    iDay = Day(dt)
    X = iYear + iMonth / 100 + iDay / 10000
    Return X
  End Function

  Protected Function GetTime() As Double
    Dim iHour, iMinute, iSecond As Integer
    Dim dt As Date = Now()
    Dim X As Double

    iHour = Hour(dt)
    iMinute = Minute(dt)
    iSecond = Second(dt)
    X = iHour + iMinute / 100 + iSecond / 10000
    Return X
  End Function


  Protected Function IsAnRpnExprToken(ByVal tok As String) As Boolean
    If IsNumeric(tok.Substring(0, tok.Length)) OrElse sCat.IndexOf("," & tok.ToUpper & ",") >= 0 Then
      Return True
    Else
      sErrMessage = ""
      Return False
    End If
  End Function

  Function GetMaxMem() As Integer
    Return MAX_MEM
  End Function

  Protected Sub BackupStack()
    Dim I As Integer

    For I = 1 To STACK_SIZE
      LastStack(I) = Stack(I)
    Next
  End Sub

  Public Function IsIndexValid(ByVal I As Integer) As Boolean
    Return I >= 0 AndAlso I <= MAX_MEM
  End Function

  Public Function Sqr(ByVal X As Double) As Double
    Return X * X
  End Function

  Protected Sub Push(ByVal X As Double)
    Dim I As Integer

    For I = STACK_SIZE To 2 Step -1
      Stack(I) = Stack(I - 1)
    Next
    Stack(X_STACK_REG) = X
  End Sub

  Private Sub Pop2()

    Stack(Y_STACK_REG) = Stack(Z_STACK_REG)
    Stack(Z_STACK_REG) = Stack(T_STACK_REG)
  End Sub

  Private Sub Pop3()

    Stack(Y_STACK_REG) = Stack(T_STACK_REG)
    Stack(Z_STACK_REG) = Stack(T_STACK_REG)
  End Sub

  Public Sub Enter(ByVal X As Double)
    Push(X)
  End Sub

  Public Sub Enter()
    Dim I As Integer

    For I = STACK_SIZE To 2 Step -1
      Stack(I) = Stack(I - 1)
    Next
  End Sub

  Private Sub SwapStackRegs(ByVal I As Byte, ByVal J As Byte)
    Dim Buffer As Double

    Buffer = Stack(I)
    Stack(I) = Stack(J)
    Stack(J) = Buffer
  End Sub

  Private Sub SwapWithMem(ByVal tok As String, ByVal StackRegIndex As Integer)
    Dim s As String
    Dim I As Integer
    Dim X As Double

    Try
      s = tok.Substring(3).Trim
      I = ParseInt(s)
      If I >= 0 AndAlso I <= MAX_MEM Then
        X = Stack(StackRegIndex)
        Stack(StackRegIndex) = Mem(I)
        Mem(I) = X
      Else
        sErrMessage = "Invalid index in swap with memory registers command"
      End If
    Catch
      sErrMessage = "Error in swap with memory registers command"
    End Try
  End Sub

  Private Sub RollDown()
    Dim X As Double

    X = Stack(X_STACK_REG)
    For i = 1 To STACK_SIZE - 1
      Stack(i) = Stack(i + 1)
    Next
    Stack(T_STACK_REG) = X
  End Sub

  Private Sub RollUp()
    Dim X As Double

    X = Stack(T_STACK_REG)
    For i = STACK_SIZE To 2 Step -1
      Stack(i) = Stack(i - 1)
    Next
    Stack(X_STACK_REG) = X
  End Sub

  Protected Function Search(ByVal FindX As Double, ByVal Optional First As Integer = 0,
                            ByVal Optional Tolerance As Double = 0,
                            ByVal Optional SearchMode As Integer = 0) As Integer
    Const IS_GREATER = 1
    Const IS_LESS = -1
    Dim I As Integer

    SearchMode = Sign(SearchMode) ' to take +1, 0, -1 values

    Select Case SearchMode
      Case IS_LESS
        If First >= 0 Then
          ' perform forward search
          For I = First To MAX_MEM
            If Mem(I) < FindX Then
              Return I
            End If
          Next
        Else
          ' perform backward search
          First = -First
          If First > MAX_MEM Then First = MAX_MEM
          For I = First To 0 Step -1
            If Mem(I) < FindX Then
              Return I
            End If
          Next
        End If

      Case IS_GREATER
        If First >= 0 Then
          ' perform forward search
          For I = First To MAX_MEM
            If Mem(I) > FindX Then
              Return I
            End If
          Next
        Else
          ' perform backward search
          First = -First
          If First > MAX_MEM Then First = MAX_MEM
          For I = First To 0 Step -1
            If Mem(I) > FindX Then
              Return I
            End If
          Next
        End If

      Case Else ' IS_EQUAL
        If First >= 0 Then
          ' perform forward search
          For I = First To MAX_MEM
            If Abs(Mem(I) - FindX) <= Tolerance Then
              Return I
            End If
          Next
        Else
          ' perform backward search
          First = -First
          If First > MAX_MEM Then First = MAX_MEM
          For I = First To 0 Step -1
            If Abs(Mem(I) - FindX) <= Tolerance Then
              Return I
            End If
          Next
        End If
    End Select
    Return -1
  End Function

  Public Function MiddleFirstSearch(ByVal FindX As Double, ByVal Optional Tolerance As Double = 0,
                                 ByVal Optional SearchMode As Integer = 0) As Integer
    Const IS_GREATER = 1
    Const IS_LESS = -1
    Dim Iup, Idown As Integer

    SearchMode = Sign(SearchMode) ' to take +1, 0, -1 values
    Iup = MAX_MEM \ 2
    Idown = Iup

    Select Case SearchMode
      Case IS_LESS
        ' start in the middle
        If Mem(Iup) < FindX Then
          Return Iup
        End If

        Do Until Idown <= 0 And Iup >= MAX_MEM

          If Idown > 0 Then
            Idown -= 1
            If Mem(Idown) < FindX Then
              Return Idown
            End If
          End If

          If Iup < MAX_MEM Then
            Iup += 1
            If Mem(Iup) < FindX Then
              Return Iup
            End If
          End If
        Loop
      Case IS_GREATER
        ' start in the middle
        If Mem(Iup) > FindX Then
          Return Iup
        End If

        Do Until Idown <= 0 And Iup >= MAX_MEM

          If Idown > 0 Then
            Idown -= 1
            If Mem(Idown) > FindX Then
              Return Idown
            End If
          End If

          If Iup < MAX_MEM Then
            Iup += 1
            If Mem(Iup) > FindX Then
              Return Iup
            End If
          End If
        Loop
      Case Else ' is equal
        ' start in the middle
        If Abs(Mem(Iup) - FindX) <= Tolerance Then
          Return Iup
        End If

        Do Until Idown <= 0 And Iup >= MAX_MEM

          If Idown > 0 Then
            Idown -= 1
            If Abs(Mem(Idown) - FindX) <= Tolerance Then
              Return Idown
            End If
          End If

          If Iup < MAX_MEM Then
            Iup += 1
            If Abs(Mem(Iup) - FindX) <= Tolerance Then
              Return Iup
            End If
          End If
        Loop
    End Select
    Return -1
  End Function


  Protected Function CircularSearch(ByVal FindX As Double, ByVal Optional First As Integer = 0,
                                    ByVal Optional Tolerance As Double = 0,
                                    ByVal Optional SearchMode As Integer = 0) As Integer
    Const IS_GREATER = 1
    Const IS_LESS = -1
    Dim I As Integer

    SearchMode = Sign(SearchMode) ' to take +1, 0, -1 values

    Select Case SearchMode
      Case IS_LESS
        If First >= 0 Then
          ' forward circular search 
          ' perform search from First element to the end
          For I = First To MAX_MEM
            If Mem(I) < FindX Then
              Return I
            End If
          Next

          ' perform search from the bgeinning to the First-1 element
          For I = 0 To First - 1
            If Mem(I) < FindX Then
              Return I
            End If
          Next
        Else
          ' backward circular search 
          First = -First
          ' perform search from the bgeinning to the First-1 element
          For I = First To 0 Step -1
            If Mem(I) < FindX Then
              Return I
            End If
          Next

          ' perform search the end to the First element 
          For I = MAX_MEM To First + 1 Step -1
            If Mem(I) < FindX Then
              Return I
            End If
          Next

        End If
      Case IS_GREATER
        If First >= 0 Then
          ' forward circular search 
          ' perform search from First element to the end
          For I = First To MAX_MEM
            If Mem(I) > FindX Then
              Return I
            End If
          Next

          ' perform search from the bgeinning to the First-1 element
          For I = 0 To First - 1
            If Mem(I) > FindX Then
              Return I
            End If
          Next
        Else
          ' backward circular search 
          First = -First
          ' perform search from the bgeinning to the First-1 element
          For I = First To 0 Step -1
            If Mem(I) > FindX Then
              Return I
            End If
          Next

          ' perform search the end to the First element 
          For I = MAX_MEM To First + 1 Step -1
            If Mem(I) > FindX Then
              Return I
            End If
          Next

        End If
      Case Else ' is equal
        If First >= 0 Then
          ' forward circular search 
          ' perform search from First element to the end
          For I = First To MAX_MEM
            If Abs(Mem(I) - FindX) <= Tolerance Then
              Return I
            End If
          Next

          ' perform search from the bgeinning to the First-1 element
          For I = 0 To First - 1
            If Abs(Mem(I) - FindX) <= Tolerance Then
              Return I
            End If
          Next
        Else
          ' backward circular search 
          First = -First
          ' perform search from the bgeinning to the First-1 element
          For I = First To 0 Step -1
            If Abs(Mem(I) - FindX) <= Tolerance Then
              Return I
            End If
          Next

          ' perform search the end to the First element 
          For I = MAX_MEM To First + 1 Step -1
            If Abs(Mem(I) - FindX) <= Tolerance Then
              Return I
            End If
          Next

        End If
    End Select
    Return -1
  End Function

  Protected Function HeuristicSearch(ByVal FindX As Double,
                                     ByRef NewPosition As Integer,
                                     ByVal Optional Shift As Integer = 1,
                                     ByVal Optional First As Integer = 0,
                                     ByVal Optional Tolerance As Double = 0) As Integer
    Dim I, J As Integer
    Dim Buffer As Double

    NewPosition = -1
    If First >= 0 Then
      For I = First To MAX_MEM
        If Abs(Mem(I) - FindX) <= Tolerance Then
          J = I + Shift
          NewPosition = I
          If Shift < 0 Then
            If J >= 0 Then
              Buffer = Mem(I)
              Mem(I) = Mem(J)
              Mem(J) = Buffer
            End If
            NewPosition = J
          ElseIf Shift > 0 Then
            If J <= MAX_MEM Then
              Buffer = Mem(I)
              Mem(I) = Mem(J)
              Mem(J) = Buffer
            End If
            NewPosition = J
          End If
          Return I
        End If
      Next
    Else
      ' perform backward search
      First = -First
      If First > MAX_MEM Then First = MAX_MEM
      For I = First To 0 Step -1
        If Abs(Mem(I) - FindX) <= Tolerance Then
          J = I + Shift
          NewPosition = I
          If Shift < 0 Then
            If J >= 0 Then
              Buffer = Mem(I)
              Mem(I) = Mem(J)
              Mem(J) = Buffer
            End If
            NewPosition = J
          ElseIf Shift > 0 Then
            If J <= MAX_MEM Then
              Buffer = Mem(I)
              Mem(I) = Mem(J)
              Mem(J) = Buffer
            End If
            NewPosition = J
          End If
          Return I
        End If
      Next
    End If
    Return -1
  End Function

  Protected Sub fxSortMemAscending()
    Dim Start, N, M, SCI, First, Last As Integer
    Dim I, J, K, Offset As Integer
    Dim bInOrder As Boolean
    Dim Buffer, X(,) As Double

    Start = Fix(Stack(T_STACK_REG)) ' first element
    N = Fix(Stack(Z_STACK_REG)) ' number of variables
    M = Fix(Stack(Y_STACK_REG)) ' number of rows
    SCI = Fix(Stack(X_STACK_REG)) ' index of column used for sorting

    ReDim X(M, N)
    Try
      First = Start
      If First < 0 Or First > MAX_MEM Then
        First = 0
      End If
      Last = Start - 1 + N * M
      Do While Last > GetMaxMem()
        N -= 1
        Last = Start - 1 + N * M
      Loop

      ' copy memory registers into matrix X
      K = First
      For I = 1 To N
        For J = 1 To M
          X(I, J) = Mem(K)
          K += 1
        Next
      Next

      Offset = N
      Do While Offset > 1
        Offset = Fix(Offset * 5.0# / 11.0#)
        If Offset < 1 Then Offset = 1
        Do
          bInOrder = True
          For I = 1 To N - Offset
            J = I + Offset
            If X(I, SCI) > X(J, SCI) Then
              ' swap the rows I and J
              For K = 1 To M
                Buffer = X(I, K)
                X(I, K) = X(J, K)
                X(J, K) = Buffer
              Next
              bInOrder = False
            End If
          Next I
        Loop Until bInOrder
      Loop

      ' copy matrix X into the memory registers
      K = First
      For I = 1 To N
        For J = 1 To M
          Mem(K) = X(I, J)
          K += 1
        Next
      Next
    Catch
      sErrMessage = "Error in SORTA"
    End Try
  End Sub

  Protected Sub fxSortMemDescending()
    Dim Start, N, M, SCI, First, Last As Integer
    Dim I, J, K, Offset As Integer
    Dim bInOrder As Boolean
    Dim Buffer, X(,) As Double

    Start = Fix(Stack(T_STACK_REG)) ' first element
    N = Fix(Stack(Z_STACK_REG)) ' number of variables
    M = Fix(Stack(Y_STACK_REG)) ' number of rows
    SCI = Fix(Stack(X_STACK_REG)) ' index of column used for sorting

    ReDim X(M, N)
    Try
      First = Start
      If First < 0 Or First > MAX_MEM Then
        First = 0
      End If
      Last = Start - 1 + N * M
      Do While Last > GetMaxMem()
        N -= 1
        Last = Start - 1 + N * M
      Loop

      ' copy memory registers into matrix X
      K = First
      For I = 1 To N
        For J = 1 To M
          X(I, J) = Mem(K)
          K += 1
        Next
      Next

      Offset = N
      Do While Offset > 1
        Offset = Fix(Offset * 5.0# / 11.0#)
        If Offset < 1 Then Offset = 1
        Do
          bInOrder = True
          For I = 1 To N - Offset
            J = I + Offset
            If X(I, SCI) < X(J, SCI) Then
              ' swap the rows I and J
              For K = 1 To M
                Buffer = X(I, K)
                X(I, K) = X(J, K)
                X(J, K) = Buffer
              Next
              bInOrder = False
            End If
          Next I
        Loop Until bInOrder
      Loop

      ' copy matrix X into the memory registers
      K = First
      For I = 1 To N
        For J = 1 To M
          Mem(K) = X(I, J)
          K += 1
        Next
      Next
    Catch
      sErrMessage = "Error in SORTD"
    End Try

  End Sub

  Public Function GetX() As Double
    Return Stack(X_STACK_REG)
  End Function

  Public Function GetY() As Double
    Return Stack(Y_STACK_REG)
  End Function

  Public Function GetZ() As Double
    Return Stack(Z_STACK_REG)
  End Function

  Public Function GetT() As Double
    Return Stack(T_STACK_REG)
  End Function

  Public Sub ShowStack()
    WriteLine("T: " & Output(Stack(T_STACK_REG)))
    WriteLine("Z: " & Output(Stack(Z_STACK_REG)))
    WriteLine("Y: " & Output(Stack(Y_STACK_REG)))
    WriteLine("X: " & Output(Stack(X_STACK_REG)))
  End Sub

  Public Sub PutX(ByVal X As Double)
    Stack(X_STACK_REG) = X
  End Sub

  Public Function GetMem(ByVal I As Integer) As Double
    Try
      Return Mem(I)
    Catch
      sErrMessage = "Index out AddressOf range Integer QGetMem"
      Return 0
    End Try
  End Function

  Public Sub SetMem(ByVal I As Integer, ByVal X As Double)
    Try
      Mem(I) = X
    Catch
      sErrMessage = "Index out AddressOf range Integer QSetMem"
    End Try
  End Sub

  Public Sub MemCopy()
    Dim I, iFrom, iTo, Count As Integer
    Dim NumCopied As Integer = 0
    Dim X As Double

    X = Stack(X_STACK_REG)
    iFrom = Fix(X)
    X = X - iFrom
    X = SCALE * X
    iTo = Fix(X)
    Count = Fix(Stack(Y_STACK_REG))
    Try
      For I = iFrom To iFrom + Count - 1
        Mem(iTo) = Mem(I)
        iTo += 1
        NumCopied += 1
      Next
    Catch
      ' do nothing
    End Try

    Enter(NumCopied)
  End Sub

  Public Sub MemSwap()
    Dim I, iSrc, iTrgt, Count As Integer
    Dim NumCopied As Integer = 0
    Dim X As Double

    X = Stack(X_STACK_REG)
    iSrc = Fix(X)
    X = X - iSrc
    X = SCALE * X
    iTrgt = Fix(X)
    Count = Fix(Stack(Y_STACK_REG))
    Try
      For I = 1 To Count
        X = Mem(iSrc)
        Mem(iSrc) = Mem(iTrgt)
        Mem(iTrgt) = X
        iSrc += 1
        iTrgt += 1
        NumCopied += 1
      Next
    Catch
      ' do nothing
    End Try
    Enter(NumCopied)
  End Sub

  Protected Function GetErrMessage() As String
    Return sErrMessage
  End Function

  Protected Sub ClearErrMessage()
    sErrMessage = ""
    bErr = False
  End Sub

  Public Sub ClrStk()
    Dim I As Integer

    For I = 1 To STACK_SIZE
      Stack(I) = 0
    Next
  End Sub

  Private Sub ClearMem(ByVal Optional Range As Decimal = 0)
    Dim I As Integer
    Dim First As Integer = 0
    Dim Last As Integer = MAX_MEM
    Dim Inc As Integer = 1

    If Range > 0 Then
      First = Fix(Range)
      Range = SCALE * (Range - First)
      Last = Fix(Range)
      Range = 100 * (Range - Last)
      Inc = Max(1, Fix(Range))
    End If

    For I = First To Last Step Inc
      Mem(I) = 0
    Next
  End Sub

  Private Sub Add()
    Dim X, Y, Z As Double

    X = Stack(X_STACK_REG)
    Y = Stack(Y_STACK_REG)
    Try
      Z = Y + X
      If Not (Double.IsInfinity(Z) Or Double.IsNaN(Z)) Then
        BackupStack()
        Pop2()
        Stack(X_STACK_REG) = Z
      Else
        If Double.IsInfinity(Z) Then
          sErrMessage = "Overflow in adding " & Y & " to " & X
        Else
          sErrMessage = "Error in adding " & Y & " to " & X
        End If
      End If
    Catch
      sErrMessage = "Overflow/Error in adding " & Y & " to " & X
    End Try
  End Sub

  Private Sub Subtract()
    Dim X, Y, Z As Double

    X = Stack(X_STACK_REG)
    Y = Stack(Y_STACK_REG)
    Try
      Z = Y - X
      If Not (Double.IsInfinity(Z) Or Double.IsNaN(Z)) Then
        BackupStack()
        Pop2()
        Stack(X_STACK_REG) = Z
      Else
        If Double.IsInfinity(Z) Then
          sErrMessage = "Overflow in subtracting " & X & " freom " & Y
        Else
          sErrMessage = "Error in subtracting " & X & " freom " & Y
        End If
      End If
    Catch
      sErrMessage = "Overflow/Error in subtracting " & X & " from " & Y
    End Try
  End Sub

  Private Sub Multiply()
    Dim X, Y, Z As Double

    X = Stack(X_STACK_REG)
    Y = Stack(Y_STACK_REG)
    Try
      Z = Y * X
      If Not (Double.IsInfinity(Z) Or Double.IsNaN(Z)) Then
        BackupStack()
        Pop2()
        Stack(X_STACK_REG) = Z
      Else
        If Double.IsInfinity(Z) Then
          sErrMessage = "Overflow in multiplying " & Y & " by " & X
        Else
          sErrMessage = "Error in multiplying " & Y & " by " & X
        End If
      End If
    Catch
      sErrMessage = "Overflow/Error in multiplying " & Y & " by " & X
    End Try
  End Sub

  Private Sub Divide()
    Dim X, Y, Z As Double

    X = Stack(X_STACK_REG)
    Y = Stack(Y_STACK_REG)
    Try
      Z = Y / X
      If Not (Double.IsInfinity(Z) Or Double.IsNaN(Z)) Then
        BackupStack()
        Pop2()
        Stack(X_STACK_REG) = Z
      Else
        If Double.IsInfinity(Z) Then
          sErrMessage = "Overflow in dividing " & Y & " by " & X
        Else
          sErrMessage = "Error in dividing " & Y & " by " & X
        End If
      End If
    Catch
      sErrMessage = "Overflow in dividing " & Y & " by " & X
    End Try
  End Sub

  Private Sub Exponentiate()
    Dim X, Y, Z As Double

    X = Stack(X_STACK_REG)
    Y = Stack(Y_STACK_REG)
    Try
      Z = Y ^ X
      If Not (Double.IsInfinity(Z) Or Double.IsNaN(Z)) Then
        BackupStack()
        Pop2()
        Stack(X_STACK_REG) = Z
      Else
        If Double.IsInfinity(Z) Then
          sErrMessage = "Overflow in raising " & Y & " to the power " & X
        Else
          sErrMessage = "Error in raising " & Y & " to the power " & X
        End If
      End If
    Catch
      sErrMessage = "Overflow in raising " & Y & " to the power " & X
    End Try
  End Sub


  Private Sub Sto(ByVal s As String)
    Dim I As Integer

    I = ParseInt(s)
    If I >= 0 And I <= MAX_MEM Then
      Mem(I) = Stack(X_STACK_REG)
    Else
      sErrMessage = "Index out of range in STO command"
    End If
  End Sub

  Private Sub StoPlus(ByVal s As String)
    Dim I As Integer

    I = ParseInt(s)
    If I >= 0 And I <= MAX_MEM Then
      Mem(I) += Stack(X_STACK_REG)
    Else
      sErrMessage = "Index out of range in STOPLUS command"
    End If
  End Sub

  Private Sub StoMinus(ByVal s As String)
    Dim I As Integer

    I = ParseInt(s)
    If I >= 0 And I <= MAX_MEM Then
      Mem(I) -= Stack(X_STACK_REG)
    Else
      sErrMessage = "Index out of range in STOMINUS command"
    End If
  End Sub

  Private Sub StoMult(ByVal s As String)
    Dim I As Integer

    I = ParseInt(s)
    If I >= 0 And I <= MAX_MEM Then
      Mem(I) *= Stack(X_STACK_REG)
    Else
      sErrMessage = "Index out of range in STOMULT command"
    End If
  End Sub

  Private Sub StoDiv(ByVal s As String)
    Dim I As Integer

    I = ParseInt(s)
    If I >= 0 And I <= MAX_MEM And Stack(X_STACK_REG) <> 0 Then
      Mem(I) /= Stack(X_STACK_REG)
    Else
      sErrMessage = "Index out of range in STODIV command or Divide by zero error"
    End If
  End Sub

  Private Sub StoInd(ByVal s As String)
    Dim I, J As Integer

    I = ParseInt(s)
    If I >= 0 And I <= MAX_MEM Then
      J = Abs(Mem(I))
      If J >= 0 And J <= MAX_MEM Then
        Mem(J) = Stack(X_STACK_REG)
      Else
        sErrMessage = "Indirect index out of range in STOIND command"
      End If
    Else
      sErrMessage = "Index out of range in STOIND command"
    End If
  End Sub

  Private Sub StoIndPlus(ByVal s As String)
    Dim I, J As Integer

    I = ParseInt(s)
    If I >= 0 And I <= MAX_MEM Then
      J = Abs(Mem(I))
      If J >= 0 And J <= MAX_MEM Then
        Mem(J) += Stack(X_STACK_REG)
      Else
        sErrMessage = "Indirect index out of range in STOINDPLUS command"
      End If
    Else
      sErrMessage = "Index out of range in STOINDPLUS command"
    End If
  End Sub

  Private Sub StoIndMinus(ByVal s As String)
    Dim I, J As Integer

    I = ParseInt(s)
    If I >= 0 And I <= MAX_MEM Then
      J = Abs(Mem(I))
      If J >= 0 And J <= MAX_MEM Then
        Mem(J) -= Stack(X_STACK_REG)
      Else
        sErrMessage = "Indirect index out of range in STOINDMINUS command"
      End If
    Else
      sErrMessage = "Index out of range in STOINDMINUS command"
    End If
  End Sub

  Private Sub StoIndMult(ByVal s As String)
    Dim I, J As Integer

    I = ParseInt(s)
    If I >= 0 And I <= MAX_MEM Then
      J = Abs(Mem(I))
      If J >= 0 And J <= MAX_MEM Then
        Mem(J) *= Stack(X_STACK_REG)
      Else
        sErrMessage = "Indirect index out of range in STOINDMULT command"
      End If
    Else
      sErrMessage = "Index out of range in STOINDPLUS command"
    End If
  End Sub

  Private Sub StoIndDiv(ByVal s As String)
    Dim I, J As Integer

    I = ParseInt(s)
    If I >= 0 And I <= MAX_MEM Then
      J = Abs(Mem(I))
      If J >= 0 And J <= MAX_MEM And Stack(X_STACK_REG) <> 0 Then
        Mem(J) /= Stack(X_STACK_REG)
      Else
        sErrMessage = "Indirect index out of range in STOINDDIV command"
      End If
    Else
      sErrMessage = "Index out of range in STOINDDIV command"
    End If
  End Sub

  Private Sub Rcl(ByVal s As String)
    Dim I As Integer

    I = Abs(ParseInt(s))
    If I >= 0 And I <= MAX_MEM Then
      Enter(Mem(I))
    Else
      sErrMessage = "Index out of range in RCL command"
    End If
  End Sub

  Private Sub RclPlus(ByVal s As String)
    Dim I As Integer

    I = Abs(ParseInt(s))
    If I >= 0 And I <= MAX_MEM Then
      Stack(X_STACK_REG) += Mem(I)
    Else
      sErrMessage = "Index out of range in RCLPLUS command"
    End If
  End Sub

  Private Sub RclMinus(ByVal s As String)
    Dim I As Integer

    I = Abs(ParseInt(s))
    If I >= 0 And I <= MAX_MEM Then
      Stack(X_STACK_REG) -= Mem(I)
    Else
      sErrMessage = "Index out of range in RCLMINUS command"
    End If
  End Sub

  Private Sub RclMult(ByVal s As String)
    Dim I As Integer

    I = Abs(ParseInt(s))
    If I >= 0 And I <= MAX_MEM Then
      Stack(X_STACK_REG) *= Mem(I)
    Else
      sErrMessage = "Index out of range in RCLMULT command"
    End If
  End Sub

  Private Sub RclDiv(ByVal s As String)
    Dim I As Integer

    I = Abs(ParseInt(s))
    If I >= 0 And I <= MAX_MEM Then
      If Mem(I) <> 0 Then
        Stack(X_STACK_REG) /= Mem(I)
      Else
        sErrMessage = "Division by zero in RCLDIV command"
      End If

    Else
      sErrMessage = "Index out of range in RCLDIV command"
    End If
  End Sub

  Private Sub RclInd(ByVal s As String)
    Dim I, J As Integer

    I = Abs(ParseInt(s))
    If I >= 0 And I <= MAX_MEM Then
      J = Mem(I)
      If J >= 0 And J < MAX_MEM Then
        Enter(Mem(J))
      Else
        sErrMessage = "Indirect index out of range in RCLIND command"
      End If
    Else
      sErrMessage = "Index out of range in RCLIND command"
    End If
  End Sub

  Private Sub RclIndPlus(ByVal s As String)
    Dim I, J As Integer

    I = Abs(ParseInt(s))
    If I >= 0 And I <= MAX_MEM Then
      J = Abs(Mem(I))
      If J >= 0 And J < MAX_MEM Then
        Stack(X_STACK_REG) += Mem(J)
      Else
        sErrMessage = "Indirect index out of range in RCLINDPLUS command"
      End If
    Else
      sErrMessage = "Index out of range in RCLINDPLUS command"
    End If
  End Sub

  Private Sub RclIndMinus(ByVal s As String)
    Dim I, J As Integer

    I = Abs(ParseInt(s))
    If I >= 0 And I <= MAX_MEM Then
      J = Abs(Mem(I))
      If J >= 0 And J < MAX_MEM Then
        Stack(X_STACK_REG) -= Mem(J)
      Else
        sErrMessage = "Indirect index out of range in RCLINDMINUS command"
      End If
    Else
      sErrMessage = "Index out of range in RCLINDMINUS command"
    End If
  End Sub

  Private Sub RclIndMult(ByVal s As String)
    Dim I, J As Integer

    I = Abs(ParseInt(s))
    If I >= 0 And I <= MAX_MEM Then
      J = Abs(Mem(I))
      If J >= 0 And J < MAX_MEM Then
        Stack(X_STACK_REG) *= Mem(J)
      Else
        sErrMessage = "Indirect index out of range in RCLINDMULT command"
      End If
    Else
      sErrMessage = "Index out of range in RCLINDMULT command"
    End If
  End Sub

  Private Sub RclIndDiv(ByVal s As String)
    Dim I, J As Integer

    I = Abs(ParseInt(s))
    If I >= 0 And I <= MAX_MEM Then
      J = Abs(Mem(I))
      If J >= 0 And J < MAX_MEM Then
        If Mem(J) <> 0 Then
          Stack(X_STACK_REG) /= Mem(J)
        Else
          sErrMessage = "Division by zero in RCLINDDIVcommand"
        End If
      Else
        sErrMessage = "Indirect index out of range in RCLINDDIVcommand"
      End If
    Else
      sErrMessage = "Index out of range in RCLINDDIV command"
    End If
  End Sub

  Private Sub fxLn()
    If Stack(X_STACK_REG) > 0 Then
      BackupStack()
      Stack(X_STACK_REG) = Log(Stack(X_STACK_REG))
    Else
      sErrMessage = "Negative argument for ln(" & Stack(X_STACK_REG) & ")"
    End If
  End Sub

  Private Sub fxLog()
    If Stack(X_STACK_REG) > 0 Then
      BackupStack()
      Stack(X_STACK_REG) = Log10(Stack(X_STACK_REG))
    Else
      sErrMessage = "Negative argument for log(" & Stack(X_STACK_REG) & ")"
    End If
  End Sub

  Private Sub fxExp()
    BackupStack()
    Stack(X_STACK_REG) = Exp(Stack(X_STACK_REG))
  End Sub

  Private Sub fx10()
    BackupStack()
    Stack(X_STACK_REG) = Pow(10, Stack(X_STACK_REG))
  End Sub

  Private Sub fxReciprocal()
    If Stack(X_STACK_REG) <> 0 Then
      BackupStack()
      Stack(X_STACK_REG) = 1 / Stack(X_STACK_REG)
    Else
      sErrMessage = "Zero argument for 1/x"
    End If
  End Sub

  Private Sub fxSqrt()
    If Stack(X_STACK_REG) >= 0 Then
      BackupStack()
      Stack(X_STACK_REG) = Sqrt(Stack(X_STACK_REG))
    Else
      sErrMessage = "Negative argument for sqrt(" & Stack(X_STACK_REG) & ")"
    End If
  End Sub

  Private Sub fxX2()
    BackupStack()
    Stack(X_STACK_REG) = Sqr(Stack(X_STACK_REG))
  End Sub

  Private Sub fxSin()
    BackupStack()
    Stack(X_STACK_REG) = Sin(Stack(X_STACK_REG))
  End Sub

  Private Sub fxCos()
    BackupStack()
    Stack(X_STACK_REG) = Cos(Stack(X_STACK_REG))
  End Sub

  Private Sub fxTan()
    BackupStack()
    Stack(X_STACK_REG) = Tan(Stack(X_STACK_REG))
  End Sub

  Private Sub fxSind()
    BackupStack()
    Stack(X_STACK_REG) = Sin(Stack(X_STACK_REG) * PI / 180)
  End Sub

  Private Sub fxCosd()
    BackupStack()
    Stack(X_STACK_REG) = Cos(Stack(X_STACK_REG) * PI / 180)
  End Sub

  Private Sub fxTand()
    BackupStack()
    Stack(X_STACK_REG) = Tan(Stack(X_STACK_REG) * PI / 180)
  End Sub
  Private Sub fxSinh()
    BackupStack()
    Stack(X_STACK_REG) = Sinh(Stack(X_STACK_REG))
  End Sub

  Private Sub fxCosh()
    BackupStack()
    Stack(X_STACK_REG) = Cosh(Stack(X_STACK_REG))
  End Sub

  Private Sub fxTanh()
    BackupStack()
    Stack(X_STACK_REG) = Tanh(Stack(X_STACK_REG))
  End Sub

  Private Sub fxArcSin()
    If Abs(Stack(X_STACK_REG)) <= 1 Then
      BackupStack()
      Stack(X_STACK_REG) = Asin(Stack(X_STACK_REG))
    Else
      sErrMessage = "Invalid argument for arc sin(" & Stack(X_STACK_REG) & ")"
    End If
  End Sub

  Private Sub fxArcCos()
    If Abs(Stack(X_STACK_REG)) <= 1 Then
      BackupStack()
      Stack(X_STACK_REG) = Acos(Stack(X_STACK_REG))
    Else
      sErrMessage = "Invalid argument for arc cos(" & Stack(X_STACK_REG) & ")"
    End If
  End Sub

  Private Sub fxArcTan()
    BackupStack()
    Stack(X_STACK_REG) = Atan(Stack(X_STACK_REG))
  End Sub

  Private Sub fxArcSind()
    If Abs(Stack(X_STACK_REG)) <= 1 Then
      BackupStack()
      Stack(X_STACK_REG) = Asin(Stack(X_STACK_REG)) * 180 / PI
    Else
      sErrMessage = "Invalid argument for arc sind(" & Stack(X_STACK_REG) & ")"
    End If
  End Sub

  Private Sub fxArcCosd()
    If Abs(Stack(X_STACK_REG)) <= 1 Then
      BackupStack()
      Stack(X_STACK_REG) = Acos(Stack(X_STACK_REG)) * 180 / PI
    Else
      sErrMessage = "Invalid argument for arc cosd(" & Stack(X_STACK_REG) & ")"
    End If
  End Sub

  Private Sub fxArcTand()
    BackupStack()
    Stack(X_STACK_REG) = Atan(Stack(X_STACK_REG)) * 180 / PI
  End Sub

  Private Sub fxInt()
    BackupStack()
    Stack(X_STACK_REG) = Fix(Stack(X_STACK_REG))
  End Sub

  Private Sub fxFrac()
    BackupStack()
    Stack(X_STACK_REG) = Stack(X_STACK_REG) - Fix(Stack(X_STACK_REG))
  End Sub

  Private Function Factorial(ByVal N As Integer) As Double
    Dim prod As Double = 1

    Do While N > 1
      prod *= N
      N -= 1
    Loop
    Return prod
  End Function

  Private Sub fxIncFact()
    BackupStack()
    Stack(X_STACK_REG) = IncFactorial(Fix(Stack(Y_STACK_REG)), Fix(Stack(X_STACK_REG)))
  End Sub


  Private Function IncFactorial(ByVal First As Integer, ByVal Last As Integer) As Double
    Dim I As Integer
    Dim prod As Double = 1

    If First > Last Then
      I = First
      First = Last
      Last = I
    End If

    For I = First To Last
      prod *= I
    Next
    Return prod
  End Function

  Private Sub fxFact()
    BackupStack()
    Stack(X_STACK_REG) = Factorial(Fix(Stack(X_STACK_REG)))
  End Sub

  Private Function Permutation(M As Integer, N As Integer) As Double
    ' Statistical permutation function
    Try
      If M >= N Then
        Return Factorial(M) / Factorial(M - N)
      Else
        Return 1 / 0
      End If

    Catch
      bErr = True
      sErrMessage = "Math error in the Permutation function(" & M & "," & N & ")"
      Return 0
    End Try

  End Function

  Private Sub fxPermutation()
    Dim X As Double

    BackupStack()
    X = Permutation(Fix(Stack(X_STACK_REG)), Fix(Stack(Y_STACK_REG)))
    Pop2()
    Stack(X_STACK_REG) = X
  End Sub

  Private Function Combination(M As Integer, N As Integer) As Double
    ' Statistical combination function
    Try
      If M >= N Then
        Return Factorial(M) / Factorial(M - N) / Factorial(N)
      Else
        Return 1 / 0
      End If

    Catch
      bErr = True
      sErrMessage = "Math error in the Combination function(" & M & "," & N & ")"
      Return 0
    End Try

  End Function

  Private Sub fxCombination()
    Dim X As Double

    BackupStack()
    X = Combination(Fix(Stack(X_STACK_REG)), Fix(Stack(Y_STACK_REG)))
    Pop2()
    Stack(X_STACK_REG) = X
  End Sub

  Private Function Gamma(ByVal X As Double)
    Const MAX = 26
    Dim Sum, XPower, Prod As Double
    Static C(MAX) As Double, DataFlag As Integer
    Dim I As Integer

    If DataFlag <> 123 Then
      DataFlag = 123
      C(1) = 1
      C(2) = 0.577215664901533
      C(3) = -0.655878071520254
      C(4) = -0.0420026350340952
      C(5) = 0.166538611382292
      C(6) = -0.0421977345555443
      C(7) = -0.009621971527877
      C(8) = 0.007218943246663
      C(9) = -0.0011651675918591
      C(10) = -0.0002152416741149
      C(11) = 0.0001280502823882
      C(12) = -0.0000201348547807
      C(13) = -0.00000125049348311
      C(14) = 0.00000113302723202
      C(15) = -0.00000020563384173
      C(16) = 0.000000006116095
      C(17) = 0.00000000500200753
      C(18) = -0.0000000011812746
      C(19) = 0.00000000010434271
      C(20) = 0.00000000000778234
      C(21) = -0.0000000000036968
      C(22) = 0.00000000000051
      C(23) = -0.0000000000000206
      C(24) = -0.0000000000000054
      C(25) = 0.0000000000000014
      C(26) = 0.0000000000000001
    End If

    Prod = 1
    Do While X > 1
      X -= 1
      Prod *= X
    Loop

    Sum = 0
    XPower = X

    For I = 1 To MAX
      Sum += C(I) * XPower
      XPower *= X
    Next I

    Return Prod / Sum
  End Function

  Private Sub fxGamma()
    BackupStack()
    Stack(X_STACK_REG) = Gamma(Stack(X_STACK_REG))
  End Sub

  Private Function IncGamma(ByVal X As Double, ByVal a As Double) As Double
    Const ASWITCH = 100

    If X < 0.0 Or a <= 0.0 Then
      Return -1
    End If

    If X = 0 Then
      Return 0
    ElseIf Fix(a) >= ASWITCH Then
      Return IncGammaApprox(a, X, True)
    ElseIf X < a + 1 Then
      Return GammSer(a, X) ' Use the series representation.
    Else
      Return 1.0 - GammCf(a, X)
    End If
  End Function

  Private Sub fxIncGamma()
    BackupStack()
    Stack(X_STACK_REG) = IncGamma(Stack(X_STACK_REG), Stack(Y_STACK_REG))
  End Sub

  Private Function GammSer(ByVal a As Double, ByVal x As Double) As Double
    Const EPS As Double = 0.0000000001
    Dim Sum, Del, Ap As Double

    Ap = a
    Sum = 1 / a
    Del = Sum
    Do
      Ap += 1
      Del *= x / Ap
      Sum += Del
      If Abs(Del) < Abs(Sum) * EPS Then
        Return Sum * Exp(-x + a * Log(x) - Gln)
      End If
    Loop
  End Function

  Private Function GammCf(ByVal a As Double, ByVal x As Double) As Double
    Const FPMIN As Double = Double.MinValue
    Const EPS As Double = 0.0000000001
    Dim I As Integer
    Dim An, b, c, d, Del, h As Double

    Gln = LnGamma(a)
    b = x + 1 - a
    c = 1.0 / FPMIN
    d = 1 / b
    h = d
    I = 1
    Do
      An = -I * (I - a)
      b += 2
      d = An * d + b
      If Abs(d) < FPMIN Then d = FPMIN
      c = b + An / c
      If Abs(c) < FPMIN Then c = FPMIN
      d = 1 / d
      Del = d * c
      h *= Del
      If Abs(Del - 1) <= EPS Then Exit Do
    Loop
    Return Exp(-x + a * Log(x) - Gln) * h

  End Function

  Private Function IncGammaApprox(ByVal a As Double, ByVal x As Double, ByVal psig As Boolean) As Double
    Dim J As Integer
    Dim Xu, t, Sum, Ans As Double
    Dim A1 As Double = a - 1
    Dim LnA1 As Double = Log(A1)
    Dim SqrtA1 As Double = Sqrt(A1)
    Dim y() As Double = {0.0021695375159141994, 0.011413521097787704, 0.027972308950302116, 0.051727015600492421,
                         0.082502225484340941, 0.12007019910960293, 0.1641528330075247, 0.21442376986779355,
                         0.27051082840644336, 0.33199876341447887, 0.39843234186401943, 0.46931971407375483,
                         0.54413605556657973, 0.62232745288031077, 0.70331500465597174, 0.78649910768313447,
                         0.87126389619061517, 0.95698180152629142}
    Dim w() As Double = {0.0055657196642445571, 0.012915947284065419, 0.020181515297735382, 0.027298621498568734,
                         0.034213810770299537, 0.040875750923643261, 0.047235083490265582, 0.053244713977759692,
                         0.0588601442453248, 0.064039797355015485, 0.068745323835736408, 0.072941885005653087,
                         0.07659841064587064, 0.07968782891207167, 0.0821872667043397, 0.084078218979661945,
                         0.085346685739338721, 0.085983275670394821}
    Gln = LnGamma(a)

    If x > A1 Then
      Xu = Max(A1 + 11.5 * SqrtA1, x + 6.0 * SqrtA1)
    Else
      Xu = Max(0, Min(A1 - 7.5 * SqrtA1, x - 5.0 * SqrtA1))
    End If
    Sum = 0
    For J = 0 To 17
      t = x + (Xu - x) * y(J)
      Sum += w(J) * Exp(-(t - A1) + A1 * (Log(t) - LnA1))
    Next
    Ans = Sum * (Xu - x) * Exp(A1 * (LnA1 - 1) - Gln)
    If psig Then
      Return If(Ans > 0, 1 - Ans, -Ans)
    Else
      Return If(Ans >= 0, Ans, 1 + Ans)
    End If
  End Function

  Private Function InvIncGamma(ByVal p As Double, ByVal a As Double) As Double
    Const EPS As Double = 0.0000000001
    Dim J As Integer
    Dim x, xerr, t, u, pp, lna1, afac As Double
    Dim a1 As Double = a - 1

    Gln = LnGamma(a)
    If a <= 0 Then Return -1
    If p >= 1 Then Return Max(100, a + 100 * Sqrt(a))
    If p <= 0 Then Return 0
    If a > 1 Then
      lna1 = Log(a1)
      afac = Exp(a1 * (lna1 - 1) - Gln)
      pp = If(p < 0.5, p, 1 - p)
      t = Sqrt(-2 * Log(pp))
      x = (2.30753 + t * 0.27061) / (1 + t * (0.99229 + t * 0.04481)) - t
      If p < 0.5 Then x = -x
      x = Max(0.001, a * Pow(1 - 1 / (9 * a) - x / (3 * Sqrt(a)), 3))
    Else
      t = 1.0 - a * (0.253 + a * 0.12)
      If p < t Then
        x = Pow(p / t, 1 / a)
      Else
        x = 1 - Log(1 - (p - t) / (1 - t))
      End If
    End If

    For J = 0 To 12
      If x <= 0 Then Return 0 ' x too small To compute accurately.
      xerr = IncGamma(a, x) - p '??????????????????
      If a > 1 Then
        t = afac * Exp(-(x - a1) + a1 * (Log(x) - lna1))
      Else
        t = Exp(-x + a1 * Log(x) - Gln)
      End If
      u = xerr / t
      x -= (t = u / (1 - 0.5 * Min(1, u * ((a - 1) / x - 1)))) ' Halley's method.
      If x <= 0 Then x = 0.5 * (x + t) ' Halve old value If x tries To go negative.
      If Abs(t) < EPS * x Then Exit For
    Next

    Return x
  End Function

  Private Sub fxInvIncGamma()
    BackupStack()
    Stack(X_STACK_REG) = InvIncGamma(Stack(X_STACK_REG), Stack(Y_STACK_REG))
  End Sub

  Private Function Beta(X As Double, Y As Double)
    ' Beta function
    Try
      Return Gamma(X) * Gamma(Y) / Gamma(X + Y)
    Catch
      bErr = True
      sErrMessage = "Error in calculating Beta(" & X & "," & Y & ")"
      Return 0
    End Try
  End Function

  Private Sub fxBeta()
    Dim X As Double

    BackupStack()
    X = Beta(Stack(X_STACK_REG), Stack(Y_STACK_REG))
    Pop2()
    Stack(X_STACK_REG) = X
  End Sub

  Private Function ASinh(X As Double) As Double
    ' Inverse hyperpolic sine
    ASinh = Log(X + Sqrt(X * X + 1))
  End Function

  Private Function ACosh(X As Double) As Double
    ' Inverse hyperpolic cosine
    ACosh = Log(X + Sqrt(X * X - 1))
  End Function

  Private Function ATanh(X As Double)
    ' Inverse hyperpolic tangent
    ATanh = Log((1 + X) / (1 - X)) / 2
  End Function

  Private Sub fxASinh()
    BackupStack()

    Try
      Stack(X_STACK_REG) = ASinh(Stack(X_STACK_REG))
    Catch
      bErr = True
      sErrMessage = "Error in calculating ASinh(" & Stack(X_STACK_REG) & ")"
    End Try
  End Sub

  Private Sub fxACosh()
    BackupStack()

    Try
      Stack(X_STACK_REG) = ACosh(Stack(X_STACK_REG))
    Catch
      bErr = True
      sErrMessage = "Error in calculating ACosh(" & Stack(X_STACK_REG) & ")"
    End Try
  End Sub

  Private Sub fxATanh()
    BackupStack()

    Try
      Stack(X_STACK_REG) = ATanh(Stack(X_STACK_REG))
    Catch
      bErr = True
      sErrMessage = "Error in calculating ATanh(" & Stack(X_STACK_REG) & ")"
    End Try
  End Sub

  Private Function RandomNormal(fMean As Double, fSdev As Double) As Double
    Dim X1 As Double, X2 As Double
    Dim Y1 As Double, Y2 As Double
    Dim Pi As Double

    X1 = Rnd(1)
    X2 = Rnd(1)
    Y1 = fMean + fSdev * Sqrt(-2 * Log(X1)) * Sin(2 * Pi * X2)
    Y2 = fMean + fSdev * Sqrt(-2 * Log(X1)) * Cos(2 * Pi * X2)
    RandomNormal = If(Rnd(1) > 0.5, Y1, Y2)
  End Function

  Private Sub fxRandNorm()
    Dim X As Double

    BackupStack()
    X = RandomNormal(Stack(X_STACK_REG), Stack(Y_STACK_REG))
    Pop2()
    Stack(X_STACK_REG) = X
  End Sub

  Private Function BesselJ0(X As Double) As Double
    ' BesselJ(0,X) function
    Dim xAbs, Z As Double
    Dim W, Y, Result As Double
    Dim t1, t2 As Double

    Try
      xAbs = Abs(X)
      If xAbs < 8.0 Then
        Y = X * X
        t1 = 77392.33017 - Y * 184.9052456
        t1 = -11214424.18 + Y * t1
        t1 = 651619640.7 + Y * t1
        t1 = -13362590354.0# + Y * t1
        t1 = 57568490574.0# + Y * t1
        '    T1 = 57568490574# + _
        '            Y * (-13362590354# + Y * (651619640.7 + Y * (-11214424.18 + _
        '            Y * (77392.33017 - Y * 184.9052456))))
        t2 = 267.8532712 + Y * 1.0#
        t2 = 59272.64853 + Y * t2
        t2 = 9494680.718 + Y * t2
        t2 = 1029532985.0# + Y * t2
        t2 = 57568490411.0# + Y * t2
        '    T2 = 57568490411# + Y * (1029532985# + Y * (9494680.718 _
        '       + Y * (59272.64853 + Y * (267.8532712 + Y * 1#))))
        Result = t1 / t2
      Else
        Z = 8.0 / xAbs
        Y = Z * Z
        W = xAbs - 0.785398164
        t1 = -0.000002073370639 + Y * 0.0000002093887211
        t1 = 0.00002734510407 + Y * t1
        t1 = 1 + Y * (-0.001098628627 + Y * t1)
        '    T1 = 1# + Y * (-0.001098628627 + Y * (0.00002734510407 _
        '      + Y * (-0.000002073370639 + Y * 2.093887211E-07)))
        t2 = 0.0000007621095161 - Y * 0.0000000934935152
        t2 = -0.000006911147651 + Y * t2
        t2 = 0.0001430488765 + Y * t2
        t2 = -0.01562499995 + Y * t2
        '    T2 = -0.01562499995 + Y * (0.0001430488765 _
        '      + Y * (-0.000006911147651 + Y * (7.621095161E-07 _
        '      - Y * 9.34935152E-08)))
        Result = Sqrt(0.636619772 / xAbs) * (Cos(W) * t1 - Z * Sin(W) * t2)
      End If
      Return Result

    Catch
      bErr = True
      sErrMessage = "Error in BesselJ0 function"
      Return HIGH_VAL
    End Try
  End Function

  Private Sub fxBesselJ0()
    BackupStack()
    Stack(X_STACK_REG) = BesselJ0(Stack(X_STACK_REG))
  End Sub

  Function BesselJ1(X As Double) As Double
    ' BesselJ(1,X) function
    Dim xAbs, Z As Double
    Dim W, Y, Result, t1, t2 As Double

    Try
      xAbs = Abs(X)
      If xAbs < 8 Then
        Y = X * X
        t1 = 15704.4826 + Y * (-30.16036606)
        t1 = -2972611.439 + Y * t1
        t1 = 242396853.1 + Y * t1
        t1 = -7895059235.0# + Y * t1
        t1 = X * (72362614232.0# + Y * t1)
        '    T1 = X * (72362614232# + Y * (-7895059235# + Y * (242396853.1 _
        '      + Y * (-2972611.439 + Y * (15704.4826 + Y * (-30.16036606))))))
        t2 = 376.9991397 + Y * 1.0#
        t2 = 99447.43394 + Y * t2
        t2 = 18583304.74 + Y * t2
        t2 = 2300535178.0# + Y * t2
        t2 = 144725228442.0# + Y * t2
        '    T2 = 144725228442# + Y * (2300535178# + Y * (18583304.74 _
        '      + Y * (99447.43394 + Y * (376.9991397 + Y * 1#))))
        Result = t1 / t2
      Else
        Z = 8.0# / xAbs
        Y = Z * Z
        W = xAbs - 2.356194491
        t1 = 0.000002457520174 + Y * (-0.000000240337019)
        t1 = -0.00003516396496 + Y * t1
        t1 = 1.0# + Y * (0.00183105 + Y * t1)
        '    T1 = 1# + Y * (0.00183105 + Y * (-0.00003516396496 _
        '      + Y * (0.000002457520174 + Y * (-0.000000240337019))))
        t2 = -0.00000088228987 + Y * 0.000000105787412
        t2 = 0.000008449199096 + Y * t2
        t2 = -0.0002002690873 + Y * t2
        t2 = 0.04687499995 + Y * t2
        '    T2 = 0.04687499995 + Y * (-0.0002002690873 _
        '      + Y * (0.000008449199096 + Y * (-0.00000088228987 _
        '      + Y * 0.000000105787412)))
        Result = Sqrt(0.636619772 / xAbs) * (Cos(W) * t1 - Z * Sin(W) * t2)
        If X < 0# Then Result = -Result
      End If
      Return Result

    Catch
      bErr = True
      sErrMessage = "Error in BesselJ1 function"
      Return HIGH_VAL
    End Try
  End Function

  Private Sub fxBesselJ1()
    BackupStack()
    Stack(X_STACK_REG) = BesselJ1(Stack(X_STACK_REG))
  End Sub

  Function BesselJn(N As Double, X As Double) As Double
    ' BesselJ(n,X) function
    Const TOLER As Double = 0.0000000001
    Dim Term, Sum As Double
    Dim K, CHS As Integer

    Dim Fact, Xpow, gama, Xby2 As Double
    Dim K1 As Integer

    If N = 0 Then
      Return BesselJ0(X)
    ElseIf N = 1 Then
      Return BesselJ1(X)
    End If

    Try
      Sum = 0
      ' Note: using factors to calculate the term for the series speeds up calculatios, because
      ' these factors, such as the factorial, power of X, andthe Gamma function are not 
      ' reclaculated from scratch.
      ' setup the factors for the first iteration
      CHS = 1
      Xby2 = X / 2
      Xpow = Pow(Xby2, N)
      Xby2 = Xby2 * Xby2
      Fact = 1
      gama = Gamma(N + 1)
      For K = 0 To 1000
        ' Originally Term was calculated using:
        ' Term = CHS / Factorial(K) * Pow(X / 2, N + 2 * K) / Gamma(K + N + 1)   
        Term = CHS / Fact * Xpow / gama
        Sum += Term
        ' update factors for the next iteration
        CHS = -CHS
        K1 = K + 1
        Fact *= K1
        Xpow *= Xby2
        gama *= (K1 + N)
        If Abs(Term) < TOLER Then Exit For
      Next
      Return Sum
    Catch
      bErr = True
      sErrMessage = "Error in BesselJn function"
      Return HIGH_VAL
    End Try

  End Function

  Private Sub fxBesselJn()
    Dim X As Double

    BackupStack()
    X = BesselJn(Stack(Y_STACK_REG), Stack(X_STACK_REG))
    Pop2()
    Stack(X_STACK_REG) = X
  End Sub

  Function BesselY0(X As Double) As Double
    ' BesselY(0,X) function
    Dim Z As Double
    Dim W, Y, Result As Double
    Dim t1, t2 As Double

    Try
      If X < 8 Then
        Y = X * X
        t1 = -86327.92757 + Y * 228.4622733
        t1 = 10879881.29 + Y * t1
        t1 = -512359803.6 + Y * t1
        t1 = 7062834065.0# + Y * t1
        t1 = -2957821389.0# + Y * t1

        '    T1 = -2957821389# + Y * (7062834065# + Y * (-512359803.6 _
        '      + Y * (10879881.29 + Y * (-86327.92757 + Y * 228.4622733))))
        t2 = 226.1030244 + Y * 1.0#
        t2 = 47447.2647 + Y * t2
        t2 = 7189466.438 + Y * t2
        t2 = 745249964.8 + Y * t2
        t2 = 40076544269.0# + Y * t2
        '    T2 = 40076544269# + Y * (745249964.8 + Y * (7189466.438 _
        '     + Y * (47447.2647 + Y * (226.1030244 + Y * 1#))))
        Result = (t1 / t2) + 0.636619772 * BesselJ0(X) * Log(X)
      Else
        Z = 8.0# / X
        Y = Z * Z
        W = X - 0.785398164
        t1 = -0.000002073370639 + Y * 0.0000002093887211
        t1 = 0.00002734510407 + Y * t1
        t1 = 1.0# + Y * (-0.001098628627 + Y * t1)
        '    T1 = 1# + Y * (-0.001098628627 + Y * (0.00002734510407 _
        '      + Y * (-0.000002073370639 + Y * 2.093887211E-07)))
        t2 = 0.0000007621095161 + Y * (-0.0000000934945152)
        t2 = -0.000006911147651 + Y * t2
        t2 = 0.0001430488765 + Y * t2
        t2 = -0.01562499995 + Y * t2
        '    T2 = -0.01562499995 + Y * (0.0001430488765 _
        '      + Y * (-0.000006911147651 + Y * (7.621095161E-07 _
        '      + Y * (-9.34945152E-08))))
        Result = Sqrt(0.636619772 / X) * (Sin(W) * t1 + Z * Cos(W) * t2)
      End If
      Return Result
    Catch
      bErr = True
      sErrMessage = "Error in BesseY0 function"
      Return HIGH_VAL
    End Try
  End Function

  Private Sub fxBessely0()
    BackupStack()
    Stack(X_STACK_REG) = BesselY0(Stack(X_STACK_REG))
  End Sub

  Function BesselY1(X As Double) As Double
    ' BesselY(1,X) function
    Dim Z, W, Y As Double
    Dim Result, t1, t2 As Double

    Try
      If X < 8 Then
        Y = X * X
        t1 = -4237922.726 + Y * 8511.937935
        t1 = 734926455.1 + Y * t1
        t1 = -51534381390.0# + Y * t1
        t1 = 1275274390000.0# + Y * t1
        t1 = X * (-4900604943000.0# + Y * t1)
        '    T1 = X * (-4900604943000# + Y * (1275274390000# _
        '      + Y * (-51534381390# + Y * (734926455.1 _
        '      + Y * (-4237922.726 + Y * 8511.937935)))))
        t2 = 102042.605 + Y * (354.9632885 + Y)
        t2 = 22459040.02 + Y * t2
        t2 = 3733650367.0# + Y * t2
        t2 = 424441966400.0# + Y * t2
        t2 = 24995805700000.0# + Y * t2
        '    T2 = 24995805700000# + Y * (424441966400# _
        '      + Y * (3733650367# + Y * (22459040.02 _
        '      + Y * (102042.605 + Y * (354.9632885 + Y)))))
        Result = (t1 / t2) + 0.636619772 * (BesselJ1(X) * Log(X) - 1.0# / X)
      Else
        Z = 8.0 / X
        Y = Z * Z
        W = X - 2.356194491
        t1 = 0.000002457520174 + Y * (-0.000000240337019)
        t1 = -0.00003516396496 + Y * t1
        t1 = 0.000002457520174 + Y * t1
        t1 = -0.00003516396496 + Y * t1
        t1 = 1.0# + Y * (0.00183105 + Y * t1)
        '    T1 = 1# + Y * (0.00183105 + Y * (-0.00003516396496 _
        '      + Y * (0.000002457520174 + Y * (-0.000000240337019))))
        t2 = -0.00000088228987 + Y * 0.000000105787412
        t2 = 0.000008449199096 + Y * t2
        t2 = -0.0002002690873 + Y * t2
        t2 = 0.04687499995 + Y * t2
        '    T2 = 0.04687499995 + Y * (-0.0002002690873 _
        '      + Y * (0.000008449199096 + Y * (-0.00000088228987 _
        '      + Y * 0.000000105787412)))
        Result = Sqrt(0.636619772 / X) * (Sin(W) * t1 + Z * Cos(W) * t2)
      End If
      Return Result
    Catch
      bErr = True
      sErrMessage = "Error in BesseY1 function"
      Return HIGH_VAL
    End Try
  End Function

  Private Sub fxBesselY1()
    BackupStack()
    Stack(X_STACK_REG) = BesselY1(Stack(X_STACK_REG))
  End Sub

  Function BesselYn(N As Double, X As Double) As Double
    ' BesselY(n,X) function
    Dim J As Long
    Dim By, Bym, Byp, Tox As Double

    Try
      If N >= 2 Then
        Tox = 2.0# / X
        By = BesselY1(X) 'Starting values for the recurrence.
        Bym = BesselY0(X)
        For J = 1 To N - 1
          Byp = J * Tox * By - Bym
          Bym = By
          By = Byp
        Next J
      Else
        If N = 1 Then
          By = BesselY1(X)
        ElseIf N = 0 Then
          By = BesselY0(X)
        Else
          By = HIGH_VAL
        End If
      End If
      Return By
    Catch
      bErr = True
      sErrMessage = "Error in BesseYn function"
      Return HIGH_VAL
    End Try

  End Function

  Private Sub fxBesselYn()
    Dim X As Double

    BackupStack()
    X = BesselJn(Stack(Y_STACK_REG), Stack(X_STACK_REG))
    Pop2()
    Stack(X_STACK_REG) = X
  End Sub

  Function Chebyshev(N As Long, X As Double) As Double
    ' Chebyshev function
    Dim C0, C1, C2 As Double
    Dim I As Long

    Try
      If N = 0 Then
        Return 1
      ElseIf N = 1 Then
        Return X
      ElseIf N > 1 Then
        'Chebyshev = 2 * X * Chebyshev(N - 1, X) - Chebyshev(N - 2, X)
        C0 = 1
        C1 = X
        For I = 2 To N
          C2 = 2 * X * C1 - C0
          C0 = C1
          C1 = C2
        Next I
        Return C2
      Else
        Return HIGH_VAL
      End If

    Catch
      bErr = True
      sErrMessage = "Error in Chebyshev function"
      Return 0
    End Try
  End Function

  Private Sub fxChebyshev()
    Dim X As Double

    BackupStack()
    X = Chebyshev(Fix(Stack(Y_STACK_REG)), Stack(X_STACK_REG))
    Pop2()
    Stack(X_STACK_REG) = X
  End Sub

  Function Legendre(N As Long, X As Double) As Double
    ' Legendre function
    Dim L0, L1, L2 As Double
    Dim I As Long

    Try
      If N = 0 Then
        Return 1
      ElseIf N = 1 Then
        Return X
      ElseIf N > 1 Then
        ' Legendre = ((2 * N - 1) * X * Legendre(N - 1, X) - (N - 1) * Legendre(N - 2, X)) / N
        L0 = 1
        L1 = X
        For I = 2 To N
          L2 = ((2 * I - 1) * X * L1 - (I - 1) * L0) / I
          L0 = L1
          L1 = L2
        Next I
        Return L2
      Else
        Return HIGH_VAL
      End If

    Catch
      bErr = True
      sErrMessage = "Error in Legendre function"
      Return 0
    End Try
  End Function

  Private Sub fxLegendre()
    Dim X As Double

    BackupStack()
    X = Legendre(Fix(Stack(Y_STACK_REG)), Stack(X_STACK_REG))
    Pop2()
    Stack(X_STACK_REG) = X
  End Sub

  Function Hermite(N As Long, X As Double) As Double
    ' Hermite function
    Dim H0, H1, H2 As Double
    Dim I As Long

    Try
      If N = 0 Then
        Return 1
      ElseIf N = 1 Then
        Return 2 * X
      ElseIf N > 1 Then
        ' Hermite = 2 * X * Hermite(N - 1, X) - 2 * (N - 1) * Hermite(N - 2, X)
        H0 = 1
        H1 = 2 * X
        For I = 2 To N
          H2 = 2 * X * H1 - 2 * (I - 1) * H0
          H0 = H1
          H1 = H2
        Next I
        Return H2
      Else
        Return HIGH_VAL
      End If

    Catch
      bErr = True
      sErrMessage = "Error in Hermite function"
      Return 0
    End Try
  End Function

  Private Sub fxHermite()
    Dim X As Double

    BackupStack()
    X = Hermite(Fix(Stack(Y_STACK_REG)), Stack(X_STACK_REG))
    Pop2()
    Stack(X_STACK_REG) = X
  End Sub

  Function Laguerre(N As Long, X As Double) As Double
    ' Laguerre function
    Dim L0, L1, L2 As Double
    Dim I As Long

    Try
      If N = 0 Then
        Return 1
      ElseIf N = 1 Then
        Return 1 - X
      ElseIf N > 1 Then
        ' Implement the following recursive relation
        ' Laguerre = ((2 * N - 1 - X) * Laguerre(N - 1, X) - (N - 1) * Laguerre(N - 2, X)) / N
        L0 = 1
        L1 = 1 - X
        For I = 2 To N
          L2 = ((2 * I - 1 - X) * L1 - (I - 1) * L0) / I
          L0 = L1
          L1 = L2
        Next I
        Return L2
      Else
        Return HIGH_VAL
      End If

    Catch
      bErr = True
      sErrMessage = "Error in Laguerre function"
      Return 0
    End Try
  End Function

  Private Sub fxLaguerre()
    Dim X As Double

    BackupStack()
    X = Laguerre(Fix(Stack(Y_STACK_REG)), Stack(X_STACK_REG))
    Pop2()
    Stack(X_STACK_REG) = X
  End Sub

  Private Function Erf(X As Double) As Double
    ' Error function
    Dim Res As Double

    Res = Erfc(X)
    Return If(Res < HIGH_VAL, 1 - Res, HIGH_VAL)
  End Function

  Private Sub fxErf()
    BackupStack()
    Stack(X_STACK_REG) = Erf(Stack(X_STACK_REG))
  End Sub

  Private Function InvErf(p As Double) As Double
    ' Error function
    Dim Res As Double

    Res = InvErfc(1 - p)
    Return If(Res <= HIGH_VAL, Res, HIGH_VAL)
  End Function

  Private Sub fxInvErf()
    BackupStack()
    Stack(X_STACK_REG) = InvErf(Stack(X_STACK_REG))
  End Sub


  Private Function Erfc(X As Double) As Double
    ' Complimentary error function
    Dim Z As Double, T As Double
    Dim Res As Double

    Try
      Z = Abs(X)
      T = 1 / (1 + 0.5 * Z)
      Res = -0.82215223 + T * 0.17087277
      Res = 1.48851587 + T * Res
      Res = -1.13520398 + T * Res
      Res = 0.27886807 + T * Res
      Res = -0.18628806 + T * Res
      Res = 0.09678418 + T * Res
      Res = 0.37409196 + T * Res
      Res = 1.00002368 + T * Res
      Res = T * Exp(-Z * Z - 1.26551223 + T * Res)
      Res = T * Exp(-Z * Z - 1.26551223 + T * (1.00002368 +
            T * (0.37409196 + T * (0.09678418 +
            T * (-0.18628806 + T * (0.27886807 + T * (-1.13520398 +
            T * (1.48851587 + T * (-0.82215223 + T * 0.17087277)))))))))
      Return If(X >= 0#, Res, 2.0# - Res)
    Catch
      Return 2 * BIG_VAL
    End Try
  End Function

  Private Sub fxErfc()
    BackupStack()
    Stack(X_STACK_REG) = Erfc(Stack(X_STACK_REG))
  End Sub

  Private Function InvErfc(p As Double) As Double
    ' Imverse omplimentary error function
    Dim X, xErr, T, pp As Double

    Try
      If p <= 0 Or p >= 2 Then Return HIGH_VAL
      pp = If(p < 1, p, 2 - p)
      T = Sqrt(-2 * Log(pp / 2))
      X = -0.70711 * ((2.30753 + T * 0.27061) / (1 + T * (0.99229 + T * 0.04481)) - T)
      For j = 0 To 1
        xErr = Erfc(X) - pp
        X += xErr / (1.1283791670955126 * Exp(Sqr(X)) - X * xErr)
      Next
      Return If(p < 1, X, -X)
    Catch
      Return 2 * BIG_VAL
    End Try
  End Function

  Private Sub fxInvErfc()
    BackupStack()
    Stack(X_STACK_REG) = InvErfc(Stack(X_STACK_REG))
  End Sub

  Private Function ExpoIntegral(X As Double) As Double
    ' Exponential integral function
    Dim Sum As Double
    Dim N As Long
    Dim Term As Double
    Dim CHS As Integer

    Try
      CHS = -1
      N = 1
      Sum = 0.5772156649 + Log(X)
      Do
        Term = X ^ N / (N * Factorial(CDbl(N)))
        Sum = Sum + Term
        N = N + 1
      Loop Until Abs(Term) < 0.00000001
      Return Sum

    Catch
      Return 2 * BIG_VAL
    End Try

  End Function

  Private Sub fxExpoIntegral()
    BackupStack()
    Stack(X_STACK_REG) = ExpoIntegral(Stack(X_STACK_REG))
  End Sub

  Private Function SineIntegral(X As Double) As Double
    ' Sine integral function
    Dim Sum As Double
    Dim N As Long, I As Long
    Dim Term As Double
    Dim CHS As Long

    Try
      CHS = -1
      N = 1
      Sum = X
      Do
        I = 2 * N + 1
        Term = CHS * X ^ I / (I * Factorial(CDbl(I)))
        Sum = Sum + Term
        CHS = -1 * CHS
        N = N + 1
      Loop Until Abs(Term) < 0.00000001
      Return Sum

    Catch
      Return 2 * BIG_VAL
    End Try
  End Function

  Private Sub fxSineIntegral()
    BackupStack()
    Stack(X_STACK_REG) = SineIntegral(Stack(X_STACK_REG))
  End Sub

  Private Function CosineIntegral(X As Double) As Double
    ' Cosine integral function
    Dim Sum As Double
    Dim N As Long, I As Long
    Dim Term As Double
    Dim CHS As Long

    Try
      CHS = -1
      N = 1
      Sum = 0.5772156649 + Log(X)
      Do
        I = 2 * N
        Term = CHS * X ^ I / (I * Factorial(CDbl(I)))
        Sum = Sum + Term
        CHS = -1 * CHS
        N = N + 1
      Loop Until Abs(Term) < 0.00000001
      Return Sum
    Catch
      Return 2 * BIG_VAL
    End Try
  End Function

  Private Sub fxCosineIntegral()
    BackupStack()
    Stack(X_STACK_REG) = CosineIntegral(Stack(X_STACK_REG))
  End Sub

  Private Sub fxMeanSdev()
    Dim X As Decimal
    Dim I, aaa, bbb, cc As Integer
    Dim N, SumX, SumX2 As Double

    Try
      X = Abs(Stack(X_STACK_REG))
      aaa = Fix(X)
      X = X - aaa
      X = SCALE * X
      bbb = Fix(X)
      X = X - bbb
      ' swap aaa and bbb if aaa > bbb
      If aaa > bbb Then
        cc = aaa
        aaa = bbb
        bbb = cc
      End If

      X = SCALE * X
      cc = Fix(100 * X)
      If cc = 0 Then cc = 1

      N = 0
      SumX = 0
      SumX2 = 0
      For I = aaa To bbb Step cc
        X = Mem(I)
        SumX += X
        SumX2 += X * X
        N += 1
      Next

      ' calc and enter sdev
      BackupStack()
      Stack(Y_STACK_REG) = Sqrt((SumX2 - Sqr(SumX) / N) / (N - 1))
      Stack(X_STACK_REG) = SumX / N
    Catch
      bErr = True
      sErrMessage = "Error in the MEANSDEV command"
    End Try
  End Sub

  Private Sub fxAbs()
    BackupStack()
    Stack(X_STACK_REG) = Abs(Stack(X_STACK_REG))
  End Sub

  Private Sub fxMod()
    Dim X, Y, Z As Double

    X = Stack(X_STACK_REG)
    Y = Stack(Y_STACK_REG)

    Try
      Z = Y Mod X
      BackupStack()
      Stack(X_STACK_REG) = Z
      Pop2()
    Catch
      bErr = True
      sErrMessage = "Error in MOD command"
    End Try
  End Sub

  Protected Function IsPrime(ByVal N As Long) As Boolean
    Dim I, M As Long

    M = Sqrt(N) + 1
    For I = 2 To M
      If N Mod I = 0 Then
        Return False
      End If
    Next
    Return True
  End Function

  Private Function NextPrime(ByVal N As Long) As Long

    Do
      N += 1
    Loop Until IsPrime(N) Or N = Long.MaxValue
    Return N
  End Function

  Private Function PrevPrime(ByVal N As Long) As Long

    Do
      N -= 1
    Loop Until IsPrime(N) Or N < 2
    Return N
  End Function

  Private Sub fxNextPrime()
    BackupStack()
    Stack(X_STACK_REG) = NextPrime(Fix(Stack(X_STACK_REG)))
  End Sub

  Private Sub fxPrevPrime()
    BackupStack()
    Stack(X_STACK_REG) = PrevPrime(Fix(Stack(X_STACK_REG)))
  End Sub

  Private Function Fibonacci(ByVal N As Long)
    Dim Y, Phi As Double

    Try
      Phi = (1 + Sqrt(5)) / 2
      Y = (Pow(Phi, N) - Pow(1 - Phi, N)) / (2 * Phi - 1)
      Return Y
    Catch
      bErr = True
      sErrMessage = "Error in FIB command"
      Return -1
    End Try
  End Function

  Private Sub fxFibonacci()
    BackupStack()
    Stack(X_STACK_REG) = Fibonacci(Fix(Stack(X_STACK_REG)))
  End Sub

  Private Sub fxRectToPolar()
    Dim X, Y As Double

    BackupStack()
    X = Stack(X_STACK_REG)
    Y = Stack(Y_STACK_REG)
    Stack(X_STACK_REG) = Sqrt(X * X + Y * Y) ' Calculate radius
    ' calculate angle
    If X <> 0 Then
      Stack(Y_STACK_REG) = Atan(Y / X)
    Else
      Stack(Y_STACK_REG) = PI / 2 ' 90 degrees
    End If
  End Sub

  Private Sub fxPolarToRect()
    Dim R, Theta As Double

    BackupStack()
    R = Stack(X_STACK_REG)
    Theta = Stack(Y_STACK_REG)
    Stack(Y_STACK_REG) = R * Sin(Theta) ' Calculate Y
    Stack(X_STACK_REG) = R * Cos(Theta) ' Calculate X
  End Sub

  Private Function ToHMS(ByVal X As Double) As Decimal
    Dim Hr, Min, Sec, CHS As Integer
    Dim Y, Z As Decimal

    CHS = 1
    If X < 0 Then
      CHS = -1
      X = -X
    End If

    Hr = Fix(X)
    Y = 60 * (X - Hr)
    Min = Fix(Y)
    Z = 60 * (Y - Min)
    Sec = CInt(Z)
    Return CHS * (Hr + Min / 100 + Sec / 10000)
  End Function

  Private Sub fxToHMS()
    BackupStack()
    Stack(X_STACK_REG) = ToHMS(Stack(X_STACK_REG))
  End Sub

  Private Function HMS(ByVal X As Double) As Decimal
    Dim Hr, Min, Sec, CHS As Integer
    Dim Y, Z As Decimal

    CHS = 1
    If X < 0 Then
      CHS = -1
      X = -X
    End If

    Hr = Fix(X)
    Y = 100 * (X - Hr)
    Min = Fix(Y)
    Z = 1000 * (Y - Min)
    Sec = Fix(Z + 0.5)
    Return CHS * (Hr + Min / 60 + Sec / 36000)
  End Function

  Private Sub fxHMS()
    BackupStack()
    Stack(X_STACK_REG) = HMS(Stack(X_STACK_REG))
  End Sub

  Private Sub fxHMSAdd()
    Dim hms1, hms2 As Decimal
    Dim X As Decimal

    BackupStack()
    hms2 = HMS(Stack(Y_STACK_REG))
    hms1 = HMS(Stack(X_STACK_REG))
    X = ToHMS(hms2 + hms1)
    Pop2()
    Stack(X_STACK_REG) = X
  End Sub

  Private Sub fxHMSSub()
    Dim hms1, hms2 As Decimal
    Dim X As Decimal

    BackupStack()
    hms2 = HMS(Stack(Y_STACK_REG))
    hms1 = HMS(Stack(X_STACK_REG))
    X = ToHMS(hms2 - hms1)
    Pop2()
    Stack(X_STACK_REG) = X
  End Sub

  Private Sub fxClearSigma()
    StatCount = 0
    SumX = 0
    SumX2 = 0
    SumY = 0
    SumY2 = 0
    SumXY = 0
    bHaveRegressionResults = False
  End Sub

  Protected Sub fxSigmaAddFromMem(ByVal sRPN As String)
    Dim X, Y As Double
    Dim II As Decimal
    Dim First, Last, I As Integer

    BackupStack()
    II = Stack(X_STACK_REG)
    First = Fix(II)
    II = II - Fix(II)
    Last = Fix(SCALE * II)

    Try
      For I = First To Last Step 2
        X = Mem(I)
        Y = Mem(I + 1)
        ' Is there an RPN expression used to transform the data?
        If sRPN.Length > 0 Then
          ' put the values of X and Y in teh X and Y stack registers, respectively
          Stack(X_STACK_REG) = X
          Stack(Y_STACK_REG) = Y
          Calc(sRPN)
          X = Stack(X_STACK_REG)
          Y = Stack(Y_STACK_REG)
        End If
        StatCount += 1
        SumX += X
        SumX2 += X * X
        SumY += Y
        SumY2 += Y * Y
        SumXY += X * Y
      Next
      Stack(X_STACK_REG) = StatCount
      bHaveRegressionResults = False
    Catch
      sErrMessage = "Overflow or underflow in function fxSigmaAddFromMem"
    End Try
  End Sub


  Private Sub fxSigmaAdd()
    Dim X, Y As Double

    BackupStack()
    X = Stack(X_STACK_REG)
    Y = Stack(Y_STACK_REG)
    Try
      StatCount += 1
      SumX += X
      SumX2 += X * X
      SumY += Y
      SumY2 += Y * Y
      SumXY += X * Y
      Stack(X_STACK_REG) = StatCount
      bHaveRegressionResults = False
    Catch
      sErrMessage = "Overflow or underflow in function fxSigmaAdd"
    End Try
  End Sub

  Private Sub fxSigmaMinus()
    Dim X, Y As Double

    If StatCount > 0 Then
      BackupStack()
      Try
        X = Stack(X_STACK_REG)
        Y = Stack(Y_STACK_REG)
        StatCount -= 1
        SumX -= X
        SumX2 -= X * X
        SumY -= Y
        SumY2 -= Y * Y
        SumXY -= X * Y
        Stack(X_STACK_REG) = StatCount
        bHaveRegressionResults = False
      Catch
        sErrMessage = "Overflow or underflow in function fxSigmaMinus"
      End Try
    End If
  End Sub

  Private Sub fxGetMean()

    If StatCount > 0 Then
      BackupStack()
      Stack(X_STACK_REG) = SumX / StatCount
      Stack(Y_STACK_REG) = SumY / StatCount
    Else
      sErrMessage = "Insufficient data in statistical registers to calculate mean"
    End If
  End Sub

  Private Sub fxGetSdev()

    If StatCount > 1 Then
      BackupStack()

      Try
        Stack(X_STACK_REG) = Sqrt((SumX2 - SumX * SumX / StatCount) / (StatCount - 1))
      Catch
        sErrMessage = "Error in calculating the standard deviation of X"
      End Try

      Try
        Stack(Y_STACK_REG) = Sqrt((SumY2 - SumY * SumY / StatCount) / (StatCount - 1))
      Catch
        sErrMessage = "Error in calculating the standard deviation of Y"
      End Try
    Else
      sErrMessage = "Insufficient data in statistical registers to calculate std deviation"
    End If
  End Sub

  Private Sub fxGetCovar()

    If StatCount > 0 Then
      BackupStack()
      Enter(SumX2 - SumX * SumX / StatCount)
    Else
      sErrMessage = "Insufficient data in statistical registers to calculate the covariance"
    End If
  End Sub

  Private Sub fxLinearRegression()
    Dim N, Sxx, Syy, Sxy, MeanX, MeanY As Double
    If StatCount > 1 Then
      Try
        N = StatCount
        Sxx = SumX2 - SumX * SumX / N
        Syy = SumY2 - SumY * SumY / N
        Sxy = SumXY - SumX * SumY / N
        MeanX = SumX / N
        MeanY = SumY / N
        SdevX = Sqrt((SumX2 - SumX * SumX / StatCount) / (StatCount - 1))
        Slope = Sxy / Sxx
        Intercept = (SumY - Slope * SumX) / N
        R2 = Sxy * Sxy / Sxx / Syy

        Reg_SS = (SumXY - SumY * MeanX) ^ 2 / ((SdevX) ^ 2 * (N - 1))
        Total_SS = Syy
        Residual_SS = Total_SS - Reg_SS
        Residual_df = N - 2
        S = Sqrt(Residual_SS / Residual_df)

        BackupStack()
        Stack(Z_STACK_REG) = R2
        Stack(Y_STACK_REG) = Intercept
        Stack(X_STACK_REG) = Slope
        bHaveRegressionResults = True
      Catch
        sErrMessage = "Error in linear regression calculations"
      End Try
    Else
      sErrMessage = "Insufficient statistical data to perform linear regression"
    End If
  End Sub

  Private Function Yhat(ByVal X As Double) As Double
    If bHaveRegressionResults Then
      Return Intercept + Slope * X
    Else
      Return 2 * BIG_VAL
    End If
  End Function

  Private Function Xhat(ByVal Y As Double) As Double
    If bHaveRegressionResults And Slope <> 0 Then
      Return (Y - Intercept) / Slope
    Else
      Return 2 * BIG_VAL
    End If
  End Function

  Private Sub ValidateAlpha(ByRef Alpha As Double)

    Alpha = Abs(Alpha)
    If Alpha >= 1 Then
      Alpha /= 100
    End If
  End Sub

  Private Sub CIMeanX(ByVal Alpha As Double)
    Dim Mean, Sdev, CiDiff As Double

    ValidateAlpha(Alpha)
    BackupStack()
    If StatCount > 1 Then
      Mean = SumX / StatCount
      Sdev = Sqrt((SumX2 - SumX * SumX / StatCount) / (StatCount - 1))
      CiDiff = TInv((1 - Alpha) / 2, StatCount - 1) * Sdev / Sqrt(StatCount)
      Stack(Z_STACK_REG) = Mean + CiDiff
      Stack(Y_STACK_REG) = Mean
      Stack(X_STACK_REG) = Mean - CiDiff
    Else
      Stack(Z_STACK_REG) = HIGH_VAL
      Stack(Y_STACK_REG) = HIGH_VAL
      Stack(X_STACK_REG) = HIGH_VAL
    End If
  End Sub

  Private Sub CIMeanY(ByVal Alpha As Double)
    Dim Mean, Sdev, CiDiff As Double

    ValidateAlpha(Alpha)
    BackupStack()
    If StatCount > 1 Then
      Mean = SumY / StatCount
      Sdev = Sqrt((SumY2 - SumY * SumY / StatCount) / (StatCount - 1))
      CiDiff = TInv((1 - Alpha) / 2, StatCount - 1) * Sdev / Sqrt(StatCount)
      Stack(Z_STACK_REG) = Mean + CiDiff
      Stack(Y_STACK_REG) = Mean
      Stack(X_STACK_REG) = Mean - CiDiff
    Else
      Stack(Z_STACK_REG) = HIGH_VAL
      Stack(Y_STACK_REG) = HIGH_VAL
      Stack(X_STACK_REG) = HIGH_VAL
    End If
  End Sub

  Private Sub CISdevX(ByVal Alpha As Double)
    Dim Sdev As Double

    ValidateAlpha(Alpha)
    BackupStack()
    If StatCount > 1 Then
      Sdev = Sqrt((SumX2 - SumX * SumX / StatCount) / (StatCount - 1))
      Stack(Z_STACK_REG) = Sqrt((StatCount - 1) * Sdev / ChiInv((1 - Alpha) / 2, StatCount - 1))
      Stack(Y_STACK_REG) = Sdev
      Stack(X_STACK_REG) = Sqrt((StatCount - 1) * Sdev / ChiInv(1 - (1 - Alpha) / 2, StatCount - 1))
    Else
      Stack(Z_STACK_REG) = HIGH_VAL
      Stack(Y_STACK_REG) = HIGH_VAL
      Stack(X_STACK_REG) = HIGH_VAL
    End If
  End Sub

  Private Sub CISdevY(ByVal Alpha As Double)
    Dim Sdev As Double

    ValidateAlpha(Alpha)
    BackupStack()
    If StatCount > 1 Then
      Sdev = Sqrt((SumY2 - SumY * SumY / StatCount) / (StatCount - 1))
      Stack(Z_STACK_REG) = Sqrt((StatCount - 1) * Sdev / ChiInv((1 - Alpha) / 2, StatCount - 1))
      Stack(Y_STACK_REG) = Sdev
      Stack(X_STACK_REG) = Sqrt((StatCount - 1) * Sdev / ChiInv(1 - (1 - Alpha) / 2, StatCount - 1))
    Else
      Stack(Z_STACK_REG) = HIGH_VAL
      Stack(Y_STACK_REG) = HIGH_VAL
      Stack(X_STACK_REG) = HIGH_VAL
    End If
  End Sub

  Private Sub InterceptCI(ByVal Alpha As Double)
    Dim StdErrIntercept, CiDiff As Double

    ValidateAlpha(Alpha)
    BackupStack()
    If bHaveRegressionResults Then
      StdErrIntercept = S * Sqrt(SumX2 / StatCount / SdevX ^ 2 / (StatCount - 1))
      CiDiff = TInv((1 - Alpha) / 2, Residual_df) * StdErrIntercept
      BackupStack()
      Stack(Z_STACK_REG) = Intercept + CiDiff
      Stack(Y_STACK_REG) = Intercept
      Stack(X_STACK_REG) = Intercept - CiDiff
    Else
      Stack(Z_STACK_REG) = HIGH_VAL
      Stack(Y_STACK_REG) = HIGH_VAL
      Stack(X_STACK_REG) = HIGH_VAL
    End If
  End Sub


  Private Sub SlopeCI(ByVal Alpha As Double)
    Dim StdErrSlope, CiDiff As Double

    ValidateAlpha(Alpha)
    BackupStack()
    If bHaveRegressionResults Then
      StdErrSlope = S / Sqrt(SumX2 - SumX * SumX / StatCount)
      CiDiff = TInv((1 - Alpha) / 2, Residual_df) * StdErrSlope
      BackupStack()
      Stack(Z_STACK_REG) = Slope + CiDiff
      Stack(Y_STACK_REG) = Slope
      Stack(X_STACK_REG) = Slope - CiDiff
    Else
      Stack(Z_STACK_REG) = HIGH_VAL
      Stack(Y_STACK_REG) = HIGH_VAL
      Stack(X_STACK_REG) = HIGH_VAL
    End If
  End Sub

  Private Sub YhatCI(ByVal X As Double, ByVal Alpha As Double)
    Dim YHat, CiDiff, tableT, Sxx As Double

    ValidateAlpha(Alpha)
    BackupStack()
    If bHaveRegressionResults Then
      Sxx = SumX2 - SumX * SumX / StatCount
      tableT = TInv((1 - Alpha) / 2, Residual_df)
      CiDiff = Sqrt((X - MeanX) ^ 2 / Sxx + 1 / StatCount + 1) * S * tableT
      YHat = Intercept + Slope * X
      Stack(Z_STACK_REG) = YHat + CiDiff
      Stack(Y_STACK_REG) = YHat
      Stack(X_STACK_REG) = YHat - CiDiff
    Else
      Stack(Z_STACK_REG) = HIGH_VAL
      Stack(Y_STACK_REG) = HIGH_VAL
      Stack(X_STACK_REG) = HIGH_VAL
    End If
  End Sub

  Private Sub YhatCIFitted(ByVal X As Double, ByVal Alpha As Double)
    Dim YHat, CiDiff, tableT, Sxx As Double

    ValidateAlpha(Alpha)
    BackupStack()
    If bHaveRegressionResults Then
      Sxx = SumX2 - SumX * SumX / StatCount
      tableT = TInv((1 - Alpha) / 2, Residual_df)
      CiDiff = Sqrt((X - MeanX) ^ 2 / Sxx + 1 / StatCount) * S * tableT
      YHat = Intercept + Slope * X
      Stack(Z_STACK_REG) = YHat + CiDiff
      Stack(Y_STACK_REG) = YHat
      Stack(X_STACK_REG) = YHat - CiDiff
    Else
      Stack(Z_STACK_REG) = HIGH_VAL
      Stack(Y_STACK_REG) = HIGH_VAL
      Stack(X_STACK_REG) = HIGH_VAL
    End If
  End Sub

  Private Sub CIRsqr(ByVal Alpha As Double)
    Dim Se, CiDiff As Double

    ValidateAlpha(Alpha)
    BackupStack()
    If bHaveRegressionResults Then
      Se = Sqrt((1 - R2) / Residual_df)
      CiDiff = (TInv((1 - Alpha) / 2, Residual_df) * Se) ^ 2
      Stack(Z_STACK_REG) = R2 + CiDiff
      Stack(Y_STACK_REG) = R2
      Stack(X_STACK_REG) = R2 - CiDiff
    Else
      Stack(Z_STACK_REG) = HIGH_VAL
      Stack(Y_STACK_REG) = HIGH_VAL
      Stack(X_STACK_REG) = HIGH_VAL
    End If
  End Sub

  Private Sub CIR(ByVal Alpha As Double)
    Dim CiDiff, RU, RL As Double
    Dim R As Double = Sign(Slope) * Sqrt(R2)
    Dim Zr, Y As Double

    ValidateAlpha(Alpha)
    BackupStack()
    Try
      If bHaveRegressionResults Then
        Zr = Log((1 + R) / (1 - R)) / 2
        CiDiff = Zr + QInv((1 - Alpha) / 2) / Sqrt(StatCount - 3)
        RU = Zr + CiDiff
        RL = Zr - CiDiff
        Y = Exp(2 * RL)
        RL = (Y - 1) / (Y + 1)
        Y = Exp(2 * RU)
        RU = (Y - 1) / (Y + 1)
        Stack(Z_STACK_REG) = RU
        Stack(Y_STACK_REG) = R
        Stack(X_STACK_REG) = RL
      Else
        Stack(Z_STACK_REG) = HIGH_VAL
        Stack(Y_STACK_REG) = HIGH_VAL
        Stack(X_STACK_REG) = HIGH_VAL
      End If
    Catch
      Stack(Z_STACK_REG) = 1.0E+100
      Stack(Y_STACK_REG) = 1.0E+100
      Stack(X_STACK_REG) = 1.0E+100
    End Try
  End Sub

  Private Function Qcdf2(ByVal z As Double) As Double
    ' input = z-value (-inf to +inf)
    ' output = p under Standard Normal curve from -inf to z
    ' e.g., if z = 0.0, function returns 0.5000
    ' ACM Algorithm #209
    Dim y As Double ' 209 scratch variable
    Dim p As Double ' result. called 'z' in 209
    Dim w As Double ' 209 scratch variable

    If z = 0.0 Then
      p = 0.0
    Else
      y = Abs(z) / 2
      If y >= 3.0 Then
        p = 1.0
      ElseIf y < 1.0 Then
        w = y * y
        p = ((((((((0.000124818987 * w - 0.001075204047) * w + 0.005198775019) * w - 0.019198292004) * w + 0.059054035642) * w - 0.151968751364) * w + 0.319152932694) * w - 0.5319230073) * w + 0.797884560593) * y * 2.0
      Else
        y = y - 2.0
        p = (((((((((((((-0.000045255659 * y + 0.00015252929) * y - 0.000019538132) * y - 0.000676904986) * y + 0.001390604284) * y - 0.00079462082) * y - 0.002034254874) * y + 0.006549791214) * y - 0.010557625006) * y + 0.011630447319) * y - 0.009279453341) * y + 0.005353579108) * y - 0.002141268741) * y + 0.000535310849) * y + 0.999936657524
      End If
    End If

    If z > 0.0 Then
      Return (p + 1.0) / 2
    Else
      Return (1.0 - p) / 2
    End If
  End Function ' Gauss()

  Protected Function Qpdf(ByVal X As Double, ByVal Mean As Double, ByVal Sdev As Double) As Double
    Return Exp(-(((X - Mean) / Sdev) ^ 2) / 2) / Sdev / Sqrt(2 * PI)
  End Function

  Protected Function QStd(ByVal X As Double) As Double
    Return Exp(-(X ^ 2) / 2) / Sqrt(2 * PI)
  End Function

  Protected Function Tpdf(ByVal X As Double, ByVal Df As Integer) As Double

    Return Gamma((Df + 1) / 2) / Gamma(Df / 2) / Sqrt(Df * PI) / (1 + X * X / Df) ^ ((Df + 1) / 2)
  End Function

  Protected Function Chipdf(ByVal X As Double, ByVal Df As Integer) As Double
    Dim k As Double = Df / 2

    If X > 0 Then
      Return X ^ (k - 1) * Exp(-X / 2) / 2 ^ k / Gamma(k)
    Else
      Return 0
    End If
  End Function

  Protected Function Fpdf(ByVal X As Double, ByVal Df1 As Integer, ByVal Df2 As Integer) As Double
    Dim d1 As Double = Df1 / 2
    Dim d2 As Double = Df2 / 2

    Return (Df1 / Df2) ^ d1 * X ^ (d1 - 1) / (1 + Df1 / Df2 * X) ^ (d1 + d2) / Beta(d1, d2)
  End Function

  Protected Function Qcdf(ByVal X As Double) As Double
    ' Function that returns the "Normal"
    ' probability distribution integral

    Dim TwoPi As Double
    Dim I As Integer
    Dim result As Double
    Dim Sum As Double ' summation
    Dim xp As Double ' x raised to an integer power
    Dim tempo As Double
    ' Array of coefficients
    Dim B(5) As Double

    TwoPi = 8 * Atan(1)
    B(1) = 0.31938153
    B(2) = -0.356563782
    B(3) = 1.781477937
    B(4) = -1.821255978
    B(5) = 1.330274429

    tempo = 1.0# / (1.0# + 0.2316419 * X)
    ' Initialize summation
    Sum = 0#
    xp = 1.0#
    ' Loop to obtain summation term
    For I = 1 To 5
      xp *= tempo ' Update power factor
      Sum += B(I) * xp
    Next I
    ' Calculate result
    result = (Exp(-X * X / 2.0#) / Sqrt(TwoPi) * Sum)
    result = IIf(X >= 0#, 1.0# - result, result)
    Return result
  End Function

  Protected Function QInv(X As Double) As Double
    '  calculate the inverse normal.

    Dim result As Double
    Dim sum1, sum2 As Double ' Two summations used
    Dim tempo, xp As Double
    Dim I As Integer
    ' First and second coefficient array
    Dim C(0 To 3) As Double
    Dim D(0 To 3) As Double

    C(0) = 2.515517
    C(1) = 0.802853
    C(2) = 0.010328
    C(3) = 0#

    D(0) = 1.0#
    D(1) = 1.432788
    D(2) = 0.189269
    D(3) = 0.001308

    ' Check limits of x
    If X <= 0# Then X = 0.0001
    If X >= 1.0# Then X = 0.9999

    If X <= 0.5 Then
      tempo = Sqrt(Log(1.0# / X ^ 2))
    Else
      tempo = Sqrt(Log(1.0# / (1.0# - X) ^ 2))
    End If

    ' Initialize summations
    sum1 = 0#
    sum2 = 0#
    xp = 1.0#
    ' Start loop to calculate summations
    For I = 0 To 3
      sum1 += C(I) * xp
      sum2 += D(I) * xp
      xp = xp * tempo ' Update power factor
    Next I
    ' Calculate the result
    result = tempo - sum1 / sum2
    result = IIf(X > 0.5, result, -result)
    Return result ' Return sought value
  End Function

  Protected Function T(X As Double, Df As Integer) As Double
    ' Function will return the probability of
    ' obtaining a student-t statistic, x, at
    ' Df degrees of freedom.
    Dim I As Integer
    Dim Theta, Sum, Product, CosPwr, R As Double

    Theta = Atan(Abs(X) / Sqrt(Df))
    If Df Mod 2 = 0 Then
      ' Df is even
      Sum = 1
      Product = 1
      CosPwr = Cos(Theta)
      CosPwr *= CosPwr
      For I = 2 To Df - 2 Step 2
        Product *= (I - 1) / I * CosPwr
        Sum += Product
      Next
      R = Sin(Theta) * Sum
    Else
      ' Df is odd
      R = 2 * Theta / PI
      If Df > 1 Then
        Sum = 1
        Product = 1
        CosPwr = Cos(Theta)
        CosPwr *= CosPwr
        For I = 2 To Df - 3 Step 2
          Product *= I / (I + 1) * CosPwr
          Sum += Product
        Next
        R = R + 2 / PI * Cos(Theta) * (Sin(Theta) * Sum)
      End If
    End If

    If X > 0 Then
      Return (1 + R) / 2
    Else
      Return (1 - R) / 2
    End If
  End Function

  Protected Function TInv(X As Double, Df As Integer) As Double
    ' double will return the value of student-t statistic for a
    ' given probability, x, and df degrees of freedom.


    Dim Sum, xp, xq As Double
    Dim Pwr(9) As Double ' Array of powers of xq
    Dim Term(4) As Double ' Array of terms
    Dim I As Integer

    ' Check limits of x
    If X <= 0# Then X = 0.0001
    If X >= 1.0# Then X = 0.9999

    xq = QInv(X)
    Pwr(1) = xq
    ' Loop to obtain the array of powers
    For I = 2 To 9
      Pwr(I) = Pwr(I - 1) * xq
    Next I
    ' Calculate the four terms
    Term(1) = 0.25 * (Pwr(3) + Pwr(1))
    Term(2) = (5 * Pwr(5) + 16 * Pwr(3) + 3 * Pwr(1)) / 96
    Term(3) = (3 * Pwr(7) + 19 * Pwr(5) + 17 * Pwr(3) - 15 * Pwr(1)) / 384
    Term(4) = (79 * Pwr(9) + 776 * Pwr(7) + 1482 * Pwr(5) - 1920 * Pwr(3) - 945 * Pwr(1)) / 92160.0#
    ' Initialize summation and power factor
    Sum = xq
    xp = 1
    ' Loop to add terms
    For I = 1 To 4
      xp = xp * Df ' Update df power factor
      Sum = Sum + Term(I) / xp
    Next I
    Return If(X >= 0.5, Sum, -Sum)
  End Function

  Protected Function Chi(X As Double, Df As Integer) As Double
    ' Function will return the probability of obtaining a
    ' chi-squared statistic, x, at df degrees of freedom.
    Const EPS = 0.0000000001
    Dim K, J As Integer
    Dim Xby2, DfBy2, Term, Product As Double
    Dim Sum As Double = 0
    Xby2 = X / 2
    DfBy2 = Df / 2

    K = 1
    Do
      Product = 1
      For J = 1 To K
        Product *= (Df + 2 * J)
      Next
      Term = X ^ K / Product
      Sum += Term
      K += 1
    Loop Until Term < EPS Or K > 1000

    Return (Xby2 ^ DfBy2) * Exp(-Xby2) / Gamma(DfBy2 + 1) * (1 + Sum)
  End Function

  Protected Function ChiInv(X As Double, Df As Integer) As Double
    ' double will return the value of chi-squared statistic for a
    ' given probability, x, and df degrees of freedom.


    Dim k, tempo, xq As Double

    ' Check limits of x
    If X <= 0# Then X = 0.0001
    If X >= 1.0# Then X = 0.9999

    k = 2.0# / 9.0#
    xq = QInv(X)
    tempo = 1.0# - k / Df + xq * Sqrt(k / Df)
    tempo = Df * tempo ^ 3
    Return tempo ' Return sought value
  End Function

  Protected Function LnFactorial(ByVal N As Integer) As Double
    Dim Sum As Double = 0

    If N < 1 Then Return -1
    Do While N > 1
      Sum += Log(N)
      N -= 1
    Loop
    Return Sum
  End Function

  Private Function fxLnFact() As Double
    BackupStack()
    Stack(X_STACK_REG) = LnFactorial(Abs(Fix(Stack(X_STACK_REG))))
  End Function


  Protected Function LnGamma(ByVal XX As Double) As Double
    Dim J As Integer
    Dim X, Tmp, y, ser As Double
    Dim Coef() As Double = {57.156235665862923, -59.597960355475493, 14.136097974741746, -0.49191381609762019, 0.000033994649984811891,
                            0.000046523628927048578, -0.000098374475304879565, 0.00015808870322491249, -0.00021026444172410488,
                            0.00021743961811521265, -0.00016431810653676389, 0.00008441822398385275, -0.000026190838401581408, 0.0000036899182659531625}
    Try
      y = XX
      X = XX
      Tmp = X + 671 / 128 ' 5.2421875
      Tmp = (X + 0.5) * Log(Tmp) - Tmp
      ser = 0.99999999999999711
      For J = 0 To 13
        y += 1
        ser += Coef(J) / y
      Next
      Return Tmp + Log(2.5066282746310007 * ser / X)
    Catch
      ' do nothing
    End Try
    Return -1
  End Function

  Private Function fxLnGamma()
    BackupStack()
    Stack(X_STACK_REG) = LnGamma(Stack(X_STACK_REG))
  End Function

  Protected Sub SetMinVal(ByRef X As Double, ByVal MinVal As Double)
    If Abs(X) < MinVal Then
      X = MinVal
    End If
  End Sub

  Protected Function BetaCf(ByVal X As Double, ByVal a As Double, ByVal b As Double) As Double
    ' From Numerical Recipes, 3e, C++ version page 272
    Const MAX_ITERS = 10000
    Const EPSILON = 0.0000001
    Const FLOATPOINT_MIN = Double.MinValue ' or 1.0E-30
    Dim I, J As Integer
    Dim Aa, c, d, Del, h, Qab, Qam, Qap As Double

    Try
      Qab = a + b
      Qap = a + 1
      Qam = a - 1
      c = 1
      d = 1 - Qab * X / Qap
      SetMinVal(d, FLOATPOINT_MIN)
      d = 1 / d
      h = d
      For I = 1 To MAX_ITERS
        J = I + I
        Aa = I * (b - I) * X / ((Qam + J) * (a + J))
        d = 1 + Aa * d
        SetMinVal(d, FLOATPOINT_MIN)
        c = 1 + Aa / c
        SetMinVal(c, FLOATPOINT_MIN)
        d = 1 / d
        h *= d * c
        Aa = -(a + I) * (Qab + I) * X / ((a + J) * (Qap + J))
        d = 1.0 + Aa * d
        SetMinVal(d, FLOATPOINT_MIN)
        c = 1 + Aa / c
        SetMinVal(c, FLOATPOINT_MIN)
        d = 1 / d
        Del = d * c
        h *= Del
        If Abs(Del - 1) < EPSILON Then Exit For
      Next
      Return h
    Catch
      Return -1
    End Try
  End Function

  Protected Function BetaiApprox(ByVal X As Double, ByVal a As Double, ByVal b As Double) As Double
    ' From Numerical Recipes, 3e, C++ version page 272
    Dim J As Integer
    Dim Xu, t, Sum, Ans As Double
    Dim A1 As Double = a - 1
    Dim B1 As Double = b - 1
    Dim Mu As Double = a / (a + b)
    Dim LnMu As Double = Log(Mu)
    Dim LnMuc As Double = Log(1 - Mu)
    Dim y() As Double = {0.0021695375159141994, 0.011413521097787704, 0.027972308950302116, 0.051727015600492421,
                         0.082502225484340941, 0.12007019910960293, 0.1641528330075247, 0.21442376986779355,
                         0.27051082840644336, 0.33199876341447887, 0.39843234186401943, 0.46931971407375483,
                         0.54413605556657973, 0.62232745288031077, 0.70331500465597174, 0.78649910768313447,
                         0.87126389619061517, 0.95698180152629142}
    Dim w() As Double = {0.0055657196642445571, 0.012915947284065419, 0.020181515297735382, 0.027298621498568734,
                         0.034213810770299537, 0.040875750923643261, 0.047235083490265582, 0.053244713977759692,
                         0.0588601442453248, 0.064039797355015485, 0.068745323835736408, 0.072941885005653087,
                         0.07659841064587064, 0.07968782891207167, 0.0821872667043397, 0.084078218979661945,
                         0.085346685739338721, 0.085983275670394821}
    Try
      t = Sqrt(a * b / (Sqr(a + b) * (a + b + 1)))
      If X > Mu Then
        If X >= 1 Then Return 1
        Xu = Min(1, Max(Mu + 10 * t, X + 5 * t))
      Else
        If X <= 0 Then Return 0
        Xu = Max(0, Min(Mu - 10 * t, X - 5 * t))
      End If
      ' Use Gauss-Legendre quadrature
      Sum = 0
      For J = 0 To 17
        t = X + (Xu - X) * y(J)
        Sum += w(J) * Exp(A1 * (Log(t) - LnMu) + B1 * (Log(1 - t) - LnMuc))
      Next
      Dim t1, t2, t3, t4, t5 As Double
      t1 = A1 * LnMu
      t2 = LnGamma(a)
      t3 = LnGamma(b)
      t4 = LnGamma(a + b)
      t5 = B1 * LnMu
      Ans = Sum * (Xu - X) * Exp(A1 * LnMu - LnGamma(a) + B1 * LnMuc - LnGamma(b) + LnGamma(a + b))
      Return If(Ans > 0, 1 - Ans, -Ans)
    Catch
      Return -1
    End Try
  End Function

  Protected Function RegIncompleteBeta(ByVal X As Double, ByVal a As Double, ByVal b As Double) As Double
    Const SWITCH_TO_QUADRATURE_LIMIT As Integer = 3000
    Dim Bt As Double

    If a <= 0 Or b <= 0 Then Return HIGH_VAL
    If X < 0 Or X > 1 Then Return HIGH_VAL
    If X = 0 Or X = 1 Then Return X

    ' use  quadrature method?
    If a > SWITCH_TO_QUADRATURE_LIMIT And b > SWITCH_TO_QUADRATURE_LIMIT Then Return BetaiApprox(X, a, b)
    Bt = X ^ a * (1 - X) ^ b / Beta(a, b)

    If X < (a + 1.0) / (a + b + 2) Then
      ' Use continued fraction directly.
      Return Bt * BetaCf(X, a, b) / a
    Else
      'Use continued fraction after making the symmetry  transformation.
      Return 1 - Bt * BetaCf(1 - X, b, a) / b
    End If
  End Function

  Protected Function Fcdf(ByVal F As Double, ByVal Df1 As Integer, ByVal Df2 As Integer) As Double

    If Not (F = 1 And Df1 = 1 And Df2 = 1) Then
      Return RegIncompleteBeta(Df1 * F / (Df1 * F + Df2), Df1 / 2, Df2 / 2)
    Else
      Return 0.5
    End If
  End Function

  Protected Function Fcdf2(ByVal F As Double, ByVal Df1 As Integer, ByVal Df2 As Integer) As Double
    ' Use equations on page 946 (sections 26.6.4 and 26/6/5) of "Handbook of Mathematical Functions", 9th printing, 1970, 
    ' by Milton Abramowitz And Irene Stegun
    Dim ddf1, ddf2 As Double
    Dim Prod, Sum As Double
    Dim Theta As Double
    Dim X, A, B As Double
    Dim CosTheta, SinTheta As Double
    Dim CosPwr, SinPwr As Double
    Dim bDf1IsEven, bDf2IsEven, bUseOption1, bUseOption2 As Boolean

    If Df1 = 1 Or Df2 = 1 Then
      X = Df1 * F / (Df1 * F + Df2)
      If Df1 = 1 Then
        Return 1 - (1 - X) ^ (Df2 / 2)
      Else
        Return X ^ (Df1 / 2)
      End If
    End If

    bDf1IsEven = Df1 Mod 2 = 0
    bDf2IsEven = Df2 Mod 2 = 0
    If bDf1IsEven AndAlso (bDf2IsEven And Df1 < Df2) Then
      bUseOption1 = True
      bUseOption2 = False
    ElseIf bDf2IsEven Then
      bUseOption1 = False
      bUseOption2 = True
    Else
      bUseOption1 = False
      bUseOption2 = False
    End If

    X = Df2 / (Df2 + Df1 * F)
    Sum = 0
    If bUseOption1 Then
      If Df1 = 2 Then
        Sum = 1
      ElseIf Df1 = 4 Then
        Sum = 1 + Df2 / 2 * (1 - X)
      Else
        Prod = Df2 * (Df2 + 2) / 2 / 4
        Sum = 1 + Df2 / 2 * (1 - X) + Prod * (1 - X) ^ 2
        For ddf1 = 8 To Df1 Step 2
          Prod *= (Df2 + ddf1 - 4) / (ddf1 - 2)
          Sum += Prod * (1 - X) ^ ((ddf1 - 2) \ 2)
        Next
      End If
      F = X ^ (Df2 / 2) * Sum
      Return 1 - F
    ElseIf bUseOption2 Then
      If Df2 = 2 Then
        Sum = 1
      ElseIf Df2 = 4 Then
        Sum = 1 + Df1 / 2 * X
      Else
        Prod = Df1 * (Df1 + 2) / 2 / 4
        Sum = 1 + Df1 / 2 * X + Prod * X ^ 2
        For ddf2 = 8 To Df2 Step 2
          Prod *= (Df1 + ddf2 - 4) / (ddf2 - 2)
          Sum += Prod * X ^ ((ddf2 - 2) \ 2)
        Next
      End If
      F = 1 - (1 - X) ^ (Df1 / 2) * Sum
      Return 1 - F
    Else ' df1 and df2 are odd
      Theta = Atan(Sqrt(Df1 / Df2 * F))
      CosTheta = Cos(Theta)
      SinTheta = Sin(Theta)
      ' Calculate A
      If Df2 > 1 Then
        Sum = CosTheta
        Prod = 1
        CosPwr = CosTheta
        For ddf2 = 5 To Df2 Step 2
          Prod *= (ddf2 - 3) / (ddf2 - 2)
          CosPwr *= CosTheta * CosTheta
          Sum += Prod * CosPwr
        Next
        A = 2 / PI * (Theta + SinTheta * Sum)
      Else
        A = 2 * Theta / PI
      End If
      ' Calculate B
      If Df2 > 1 And Df1 >= 1 Then
        Sum = 1
        Prod = 1
        SinPwr = 1
        For ddf1 = 5 To Df1 Step 2
          Prod *= (Df2 + ddf1 - 4) / (ddf1 - 2)
          SinPwr *= SinTheta * SinTheta
          Sum += Prod * SinPwr ' SinTheta ^ (ddf1 - 3)
        Next
        B = 2 / Sqrt(PI) * Gamma((Df2 - 1) / 2 + 1) / Gamma((Df2 - 2) / 2 + 1) * SinTheta * (CosTheta ^ Df2) * Sum
      ElseIf Df1 = 1 Then
        B = 0
      Else
        B = 0
      End If
      'calculate result
      F = 1 - A + B
    End If
    Return 1 - F
  End Function

  Protected Function FInv(F As Double, Df1 As Integer, Df2 As Integer) As Double
    ' Uses Newton's method to find the root of function f(x) = Fcdf(x,df1,df2)-F
    Const TOLER As Double = 0.000001
    Const MAX_ITERS = 100
    Dim fx0, fx1, h, Diff, x As Double
    Dim Iters As Integer = 0

    ' check special cases
    If F = 0.5 And Df1 = 1 And Df2 = 1 Then
      Return 1
    End If

    Try
      x = 1
      Do
        h = 0.001 * (1 + Abs(x))
        fx0 = Fcdf(x, Df1, Df2) - F
        fx1 = Fcdf(x + h, Df1, Df2) - F
        Diff = h * fx0 / (fx1 - fx0)
        x -= Diff
        Iters += 1
      Loop Until Abs(Diff) <= TOLER Or Iters > MAX_ITERS
      Return x
    Catch
      Return 0
    End Try
  End Function

  Protected Function SumPower(ByVal X As Double, ByVal Last As Integer, ByVal Optional First As Integer = 1)
    Dim I As Integer
    Dim Sum As Double = 0
    Dim Term As Double

    First = Abs(First)
    Last = Abs(Last)
    If First = 0 Then First = 1
    If Last = 0 Then Last = 1
    ' make sure that First <= Last
    If First > Last Then
      I = First
      First = Last
      Last = I
    End If

    For I = First To Last
      Try
        Term = X ^ I
      Catch
        WriteLine("Warning! Error in calculating (" & CStr(X) & ")^(" & CStr(I) & ") in SUMPWR command")
        WriteLine("Returning " & Sum)
        Return Sum
      End Try

      Try
        Sum += Term
      Catch
        WriteLine("Warning! Error in adding " & CStr(Term) & " to sum of " & CStr(Sum) & " in SUMPWR command")
        WriteLine("Returning " & Double.MaxValue)
        Return Double.MaxValue
      End Try
    Next
    Return Sum
  End Function

  Protected Function SumNegPower(ByVal X As Double, ByVal Last As Integer, ByVal Optional First As Integer = 1)
    Dim I As Integer
    Dim Sum As Double = 0
    Dim Term As Double

    First = Abs(First)
    Last = Abs(Last)
    If First = 0 Then First = 1
    If Last = 0 Then Last = 1
    ' make sure that First <= Last
    If First > Last Then
      I = First
      First = Last
      Last = I
    End If

    For I = First To Last
      Try
        Term = 1 / X ^ I
      Catch
        WriteLine("Warning! Error in calculating 1/(" & CStr(X) & ")^(" & CStr(I) & ") in SUMNEGPWR command")
        WriteLine("Returning " & Sum)
        Return Sum
      End Try

      Try
        Sum += Term
      Catch
        WriteLine("Warning! Error in adding " & CStr(Term) & " to sum of " & CStr(Sum) & " in SUMPNEGWR command")
        WriteLine("Returning " & Double.MaxValue)
        Return Double.MaxValue
      End Try
    Next
    Return Sum
  End Function

  Protected Function SumPowerToler(ByVal X As Double, ByVal Toler As Double, ByVal Optional First As Integer = 1)
    Dim I As Integer
    Dim Sum As Double = 0
    Dim Term As Double

    If X >= 1 Then Return Double.MaxValue

    First = Max(1, Abs(First))
    Toler = Max(0.00000001, Toler)
    I = First
    Do
      Try
        Term = X ^ I
      Catch
        WriteLine("Warning! Error in calculating (" & CStr(X) & ")^(" & CStr(I) & ") in SUMPWRTOL command")
        WriteLine("Returning " & Sum)
        Return Sum
      End Try

      Try
        Sum += Term
      Catch
        WriteLine("Warning! Error in adding " & CStr(Term) & " to sum of " & CStr(Sum) & " in SUMPWRTOL command")
        WriteLine("Returning " & Double.MaxValue)
        Return Double.MaxValue
      End Try
      I += 1
    Loop Until Abs(Term) <= Toler
    Return Sum
  End Function


  Protected Function Zeta(ByVal s As Double, ByVal Toler As Double, ByVal Optional q As Double = 1)
    Const EPS = 0.0000000001
    Dim N, K, I As Integer
    Dim Sum, Sum2, Term, Comb As Double
    Dim CHS As Integer
    Dim NFact, KFact, NmKFact, Cmb As Double

    If s = 1 Or q < 1 Then Return Double.MaxValue

    Toler = Min(0.00000001, Toler)
    Try
      Sum = 0.5
      NFact = 1
      For N = 1 To 1000
        Sum2 = 1
        CHS = -1
        NFact *= N
        KFact = 1
        NmKFact = NFact
        I = N
        For K = 1 To N
          KFact *= K
          If I > 0 Then
            NmKFact /= I
            NmKFact = Max(1, NmKFact)
            I = I - 1
          End If
          Cmb = NFact / KFact / NmKFact
          Sum2 += CHS * Cmb / (K + q) ^ s
          CHS = -CHS
        Next K
        Term = Sum2 / 2 ^ (N + 1)
        Sum += Term
        If Abs(Term) < EPS Then Exit For
      Next N
    Catch
      ' do nothing .... just end the loop-centric calculations
    End Try
    Return Sum / (1 - 2 ^ (1 - s))
  End Function

  Protected Function SumNegPowerToler(ByVal X As Double, ByVal Toler As Double, ByVal Optional First As Integer = 1)
    Dim I As Integer
    Dim Sum As Double = 0
    Dim Term As Double

    If X <= 1 Then Return Double.MaxValue

    First = Max(1, Abs(First))
    Toler = Max(0.00000001, Toler)

    I = First
    Do
      Try
        Term = 1 / X ^ I
      Catch
        WriteLine("Warning! Error in calculating 1/(" & CStr(X) & ")^(" & CStr(I) & ") in SUMNEGPWRTOL command")
        WriteLine("Returning " & Sum)
        Return Sum
      End Try

      Try
        Sum += Term
      Catch
        WriteLine("Warning! Error in adding " & CStr(Term) & " to sum of " & CStr(Sum) & " in SUMPNEGWRTOL command")
        WriteLine("Returning " & Double.MaxValue)
        Return Double.MaxValue
      End Try
      I += 1
    Loop Until Abs(Term) <= Toler
    Return Sum
  End Function


  '------------------------------------------------------

  Public Sub ParseToken(ByVal tok As String)
    Dim I As Integer
    Dim X, Y, Z As Double
    Dim dt As Date

    If tok.Trim.Length = 0 Then Exit Sub
    tok = tok.ToUpper
    If IsNumeric(tok) Then
      Enter(CDbl(tok))
    ElseIf "+-*/^".IndexOf(tok) > -1 Then
      If tok = "+" Then
        Add()
      ElseIf tok = "-" Then
        Subtract()
      ElseIf tok = "*" Then
        Multiply()
      ElseIf tok = "/" Then
        Divide()
      Else ' Raise to power
        Exponentiate()
      End If
    ElseIf tok = "CLX" Then
      Stack(X_STACK_REG) = 0
    ElseIf tok = "SIGN" Then
      BackupStack()
      Stack(X_STACK_REG) = Sign(Stack(X_STACK_REG))
    ElseIf tok = "CHS" Then
      Stack(X_STACK_REG) = -Stack(X_STACK_REG)
    ElseIf tok.StartsWith("STOIND") Then
      If tok.StartsWith("STOIND+") Then
        StoIndPlus(tok.Substring(7))
      ElseIf tok.StartsWith("STOIND-") Then
        StoIndMinus(tok.Substring(7))
      ElseIf tok.StartsWith("STOIND*") Then
        StoIndMult(tok.Substring(7))
      ElseIf tok.StartsWith("STOIND/") Then
        StoIndDiv(tok.Substring(7))
      Else
        StoInd(tok.Substring(6))
      End If
    ElseIf tok.StartsWith("STOSTIND") Then
      If tok = "STOSTINDY" Then
        SetMem(Fix(Stack(Y_STACK_REG)), Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDX" Then
        SetMem(Fix(Stack(X_STACK_REG)), Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDZ" Then
        SetMem(Fix(Stack(Z_STACK_REG)), Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDT" Then
        SetMem(Fix(Stack(T_STACK_REG)), Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDX+" Then
        I = Fix(Stack(X_STACK_REG))
        SetMem(I, GetMem(I) + Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDX-" Then
        I = Fix(Stack(X_STACK_REG))
        SetMem(I, GetMem(I) - Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDX*" Then
        I = Fix(Stack(X_STACK_REG))
        SetMem(I, GetMem(I) * Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDX/" Then
        If Stack(X_STACK_REG) <> 0 Then
          I = Fix(Stack(X_STACK_REG))
          SetMem(I, GetMem(I) / Stack(X_STACK_REG))
        Else
          sErrMessage = "Error in STOSTINDX/ command"
        End If
      ElseIf tok = "STOSTINDY+" Then
        I = Fix(Stack(Y_STACK_REG))
        SetMem(I, GetMem(I) + Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDY-" Then
        I = Fix(Stack(Y_STACK_REG))
        SetMem(I, GetMem(I) - Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDY*" Then
        I = Fix(Stack(Y_STACK_REG))
        SetMem(I, GetMem(I) * Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDY/" Then
        If Stack(X_STACK_REG) <> 0 Then
          I = Fix(Stack(Y_STACK_REG))
          SetMem(I, GetMem(I) / Stack(X_STACK_REG))
        Else
          sErrMessage = "Error in STOSTINDY/ command"
        End If
      ElseIf tok = "STOSTINDZ+" Then
        I = Fix(Stack(Z_STACK_REG))
        SetMem(I, GetMem(I) + Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDZ-" Then
        I = Fix(Stack(Z_STACK_REG))
        SetMem(I, GetMem(I) - Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDZ*" Then
        I = Fix(Stack(Z_STACK_REG))
        SetMem(I, GetMem(I) * Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDZ/" Then
        If Stack(X_STACK_REG) <> 0 Then
          I = Fix(Stack(Z_STACK_REG))
          SetMem(I, GetMem(I) / Stack(X_STACK_REG))
        Else
          sErrMessage = "Error in STOSTINDZ/ command"
        End If
      ElseIf tok = "STOSTINDT+" Then
        I = Fix(Stack(T_STACK_REG))
        SetMem(I, GetMem(I) + Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDT-" Then
        I = Fix(Stack(T_STACK_REG))
        SetMem(I, GetMem(I) - Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDT*" Then
        I = Fix(Stack(T_STACK_REG))
        SetMem(I, GetMem(I) * Stack(X_STACK_REG))
      ElseIf tok = "STOSTINDT/" Then
        If Stack(X_STACK_REG) <> 0 Then
          I = Fix(Stack(T_STACK_REG))
          SetMem(I, GetMem(I) / Stack(X_STACK_REG))
        Else
          sErrMessage = "Error in STOSTINDT/ command"
        End If
      Else
        sErrMessage = "Error in the STOSTIND command"
      End If
    ElseIf tok.StartsWith("STOST") Then
      If tok = "STOSTY" Then
        Stack(Y_STACK_REG) = Stack(X_STACK_REG)
      ElseIf tok = "STOSTX" Then
        Stack(X_STACK_REG) = Stack(X_STACK_REG) ' ;-)
      ElseIf tok = "STOSTZ" Then
        Stack(Z_STACK_REG) = Stack(X_STACK_REG)
      ElseIf tok = "STOSTT" Then
        Stack(T_STACK_REG) = Stack(X_STACK_REG)
      ElseIf tok = "STOSTX+" Then
        Stack(X_STACK_REG) += Stack(X_STACK_REG)
      ElseIf tok = "STOSTX-" Then
        Stack(X_STACK_REG) = 0
      ElseIf tok = "STOSTX*" Then
        Stack(X_STACK_REG) *= Stack(X_STACK_REG)
      ElseIf tok = "STOSTX/" Then
        If Stack(X_STACK_REG) <> 0 Then
          Stack(X_STACK_REG) = 1
        Else
          sErrMessage = "Error in STOSTX/ command"
        End If
      ElseIf tok = "STOSTY+" Then
        Stack(Y_STACK_REG) += Stack(X_STACK_REG)
      ElseIf tok = "STOSTY-" Then
        Stack(Y_STACK_REG) -= Stack(X_STACK_REG)
      ElseIf tok = "STOSTY*" Then
        Stack(Y_STACK_REG) *= Stack(X_STACK_REG)
      ElseIf tok = "STOSTY/" Then
        If Stack(X_STACK_REG) <> 0 Then
          Stack(Y_STACK_REG) /= Stack(X_STACK_REG)
        Else
          sErrMessage = "Error in STOSTY/ command"
        End If
      ElseIf tok = "STOSTZ+" Then
        Stack(Z_STACK_REG) += Stack(X_STACK_REG)
      ElseIf tok = "STOSTZ-" Then
        Stack(Z_STACK_REG) -= Stack(X_STACK_REG)
      ElseIf tok = "STOSTZ*" Then
        Stack(Z_STACK_REG) *= Stack(X_STACK_REG)
      ElseIf tok = "STOSTZ/" Then
        If Stack(X_STACK_REG) <> 0 Then
          Stack(Z_STACK_REG) /= Stack(X_STACK_REG)
        Else
          sErrMessage = "Error in STOSTZ/ command"
        End If
      ElseIf tok = "STOSTT+" Then
        Stack(T_STACK_REG) += Stack(X_STACK_REG)
      ElseIf tok = "STOSTT-" Then
        Stack(T_STACK_REG) -= Stack(X_STACK_REG)
      ElseIf tok = "STOSTT*" Then
        Stack(T_STACK_REG) *= Stack(X_STACK_REG)
      ElseIf tok = "STOSTT/" Then
        If Stack(X_STACK_REG) <> 0 Then
          Stack(T_STACK_REG) /= Stack(X_STACK_REG)
        Else
          sErrMessage = "Error in STOSTT/ command"
        End If
      Else
        sErrMessage = "Error in the STOST command"
      End If
    ElseIf tok.StartsWith("RCLSTIND") Then
      If tok = "RCLSTINDX" Then
        Enter(GetMem(Fix(Stack(X_STACK_REG))))
      ElseIf tok = "RCLSTINDY" Then
        Enter(GetMem(Fix(Stack(Y_STACK_REG))))
      ElseIf tok = "RCLSTINDZ" Then
        Enter(GetMem(Fix(Stack(Z_STACK_REG))))
      ElseIf tok = "RCLSTINDT" Then
        Enter(GetMem(Fix(Stack(T_STACK_REG))))
      Else
        sErrMessage = "Error in the RCLSTIND command"
      End If
    ElseIf tok.StartsWith("RCLST") Then
      If tok = "RCLSTX" Then
        Enter(Stack(X_STACK_REG))
      ElseIf tok = "RCLSTY" Then
        Enter(Stack(Y_STACK_REG))
      ElseIf tok = "RCLSTZ" Then
        Enter(Stack(Z_STACK_REG))
      ElseIf tok = "RCLSTT" Then
        Enter(Stack(T_STACK_REG))
      Else
        sErrMessage = "Error in the RCLST command"
      End If
    ElseIf tok.StartsWith("STO") Then
      If tok.StartsWith("STO+") Then
        StoPlus(tok.Substring(4))
      ElseIf tok.StartsWith("STO-") Then
        StoMinus(tok.Substring(4))
      ElseIf tok.StartsWith("STO*") Then
        StoMult(tok.Substring(4))
      ElseIf tok.StartsWith("STO/") Then
        StoDiv(tok.Substring(4))
      Else
        Sto(tok.Substring(3))
      End If
    ElseIf tok.StartsWith("RCLIND") Then
      If tok.StartsWith("RCLIND+") Then
        RclIndPlus(tok.Substring(7))
      ElseIf tok.StartsWith("RCLIND-") Then
        RclIndMinus(tok.Substring(7))
      ElseIf tok.StartsWith("RCLIND*") Then
        RclIndMult(tok.Substring(7))
      ElseIf tok.StartsWith("RCLIND/") Then
        RclIndDiv(tok.Substring(7))
      Else
        RclInd(tok.Substring(6))
      End If
    ElseIf tok.StartsWith("RCL") Then
      If tok.StartsWith("RCL+") Then
        RclPlus(tok.Substring(4))
      ElseIf tok.StartsWith("RCL-") Then
        RclMinus(tok.Substring(4))
      ElseIf tok.StartsWith("RCL*") Then
        RclMult(tok.Substring(4))
      ElseIf tok.StartsWith("RCL/") Then
        RclDiv(tok.Substring(4))
      Else
        Rcl(tok.Substring(3))
      End If
    ElseIf tok = "-STK-" Or tok = "VIEWSTK" Or tok = "SHOWSTK" Then
      ShowStack()
    ElseIf tok = "LASTX" Then
      Enter(LastStack(X_STACK_REG))
    ElseIf tok = "LASTY" Then
      Enter(LastStack(Y_STACK_REG))
    ElseIf tok = "LASTZ" Then
      Enter(LastStack(Z_STACK_REG))
    ElseIf tok = "LASTT" Then
      Enter(LastStack(T_STACK_REG))
    ElseIf tok = "ENTER" Then
      Enter()
    ElseIf tok = "PI" Then
      Enter(PI)
    ElseIf tok.StartsWith("SCALE") Then
      If tok = "SCALE" Then
        Enter(SCALE)
      ElseIf tok = "SCALE41" Then
        Enter(SCALE41)
      Else
        sErrMessage = "Error in SCALE command"
      End If
    ElseIf tok = "MOD" Then
      fxMod()
    ElseIf tok = "Y^X" Then
      Exponentiate()
    ElseIf tok.StartsWith("X<>") AndAlso Not tok.EndsWith("?") Then
      If tok = "X<>Y" Then
        SwapStackRegs(X_STACK_REG, Y_STACK_REG)
      ElseIf tok = "X<>Z" Then
        SwapStackRegs(X_STACK_REG, Z_STACK_REG)
      ElseIf tok = "X<>T" Then
        SwapStackRegs(X_STACK_REG, T_STACK_REG)
      Else
        SwapWithMem(tok, 1)
      End If
    ElseIf tok.StartsWith("Y<>") AndAlso Not tok.EndsWith("?") Then
      If tok = "Y<>Z" Then
        SwapStackRegs(Y_STACK_REG, Z_STACK_REG)
      ElseIf tok = "Y<>Z" Then
        SwapStackRegs(Y_STACK_REG, Z_STACK_REG)
      Else
        SwapWithMem(tok, 2)
      End If
    ElseIf tok.StartsWith("Z<>") Then
      If tok = "Z<>T" Then
        SwapStackRegs(Z_STACK_REG, T_STACK_REG)
      Else
        SwapWithMem(tok, 3)
      End If
    ElseIf tok.StartsWith("T<>") Then
      SwapWithMem(tok, 4)
    ElseIf tok = "CLRDSP" Then
      DisplayFormat = ""
    ElseIf tok.StartsWith("DSP") Then
      If tok = "DSP?" Then
        WriteLine("Current display format Is {0}", GetFormat())
      Else
        SetFormat(tok.Substring(3))
      End If
    ElseIf tok.StartsWith("FIX") Then
      If tok.Substring(3).Length > 0 Then SetFormat("F" & tok.Substring(3).Trim)
    ElseIf tok.StartsWith("SCI") Then
      If tok.Substring(3).Length > 0 Then SetFormat("E" & tok.Substring(3).Trim)
    ElseIf tok = "RDN" Then
      RollDown()
    ElseIf tok = "RUP" Then
      RollUp()
    ElseIf tok = "CLST" Or tok = "CLSTK" Or tok = "CLRSTK" Then
      ClrStk()
    ElseIf tok.StartsWith("CLREG") Then
      If tok = "CLREG" Then
        ClearMem()
      ElseIf tok = "CLREGX" Then
        ClearMem(Stack(X_STACK_REG))
      ElseIf tok = "CLREGY" Then
        ClearMem(Stack(Y_STACK_REG))
      ElseIf tok = "CLREGZ" Then
        ClearMem(Stack(Z_STACK_REG))
      ElseIf tok = "CLREGT" Then
        ClearMem(Stack(T_STACK_REG))
      Else
        sErrMessage = "Invalid CLREG command"
      End If
    ElseIf tok = "ABS" Then
      fxAbs()
    ElseIf tok.StartsWith("LN") Then
      If tok = "LN" Then
        fxLn()
      ElseIf tok = "LNFACT" Then
        fxLnFact()
      Else
        sErrMessage = "Invalid type Of LN Function"
      End If
    ElseIf tok = "LOG" Then
      fxLog()
    ElseIf tok = "EXP" Then
      fxExp()
    ElseIf tok = "10^" Then
      fx10()
    ElseIf tok = "1/X" Then
      fxReciprocal()
    ElseIf tok = "X^2" Then
      fxX2()
    ElseIf tok = "SQRT" Then
      fxSqrt()
    ElseIf tok = "SIN" Then
      fxSin()
    ElseIf tok = "COS" Then
      fxCos()
    ElseIf tok = "TAN" Then
      fxTan()
    ElseIf tok = "SIND" Then
      fxSind()
    ElseIf tok = "COSD" Then
      fxCosd()
    ElseIf tok = "TAND" Then
      fxTand()
    ElseIf tok = "SINH" Then
      fxSinh()
    ElseIf tok = "COSH" Then
      fxCosh()
    ElseIf tok = "TANH" Then
      fxTanh()
    ElseIf tok = "ASIN" Then
      fxArcSin()
    ElseIf tok = "ACOS" Then
      fxArcCos()
    ElseIf tok = "ATAN" Then
      fxArcTan()
    ElseIf tok = "ASIND" Then
      fxArcSind()
    ElseIf tok = "ACOSD" Then
      fxArcCosd()
    ElseIf tok = "ATAND" Then
      fxArcTand()
    ElseIf tok = "ASINH" Then
      fxASinh()
    ElseIf tok = "ACOSH" Then
      fxACosh()
    ElseIf tok = "ATANH" Then
      fxATanh()
    ElseIf tok = "INT" Then
      fxInt()
    ElseIf tok = "FRAC" Or tok = "FRC" Then
      fxFrac()
    ElseIf tok = "FACT" Then
      fxFact()
    ElseIf tok = "IFACT" Then
      fxIncFact()
    ElseIf tok = "RAND" Then
      Enter(Rnd(1))
    ElseIf tok = "RANDNORM" Then
      fxRandNorm()
    ElseIf tok = "PERM" Then
      fxPermutation()
    ElseIf tok = "COMB" Then
      fxCombination()
    ElseIf tok = "MEANSDEV" Then
      fxMeanSdev()
    ElseIf tok = "CLEARSIGMA" Then
      fxClearSigma()
    ElseIf tok = "SIGMA+" Or tok = "S+" Then
      fxSigmaAdd()
    ElseIf tok = "SIGMA-" Or tok = "S-" Then
      fxSigmaMinus()
    ElseIf tok = "SIGMA++" Or tok = "S++" Then
      fxSigmaAddFromMem("")
    ElseIf tok = "MEAN" Then
      fxGetMean()
    ElseIf tok = "SDEV" Then
      fxGetSdev()
    ElseIf tok = "COV" Then
      fxGetCovar()
    ElseIf tok = "LRXY" Then
      fxLinearRegression()
    ElseIf tok = "YHAT" Then
      BackupStack()
      Stack(X_STACK_REG) = Yhat(Stack(X_STACK_REG))
    ElseIf tok = "XHAT" Then
      BackupStack()
      Stack(X_STACK_REG) = Xhat(Stack(X_STACK_REG))
    ElseIf tok.StartsWith("SUM") Then
      If tok = "SUMN" Then
        Enter(StatCount)
      ElseIf tok = "SUMX"
        Enter(SumX)
      ElseIf tok = "SUMX2"
        Enter(SumX2)
      ElseIf tok = "SUMY"
        Enter(SumY)
      ElseIf tok = "SUMY2"
        Enter(SumY2)
      ElseIf tok = "SUMXY"
        Enter(SumXY)
      ElseIf tok = "SUMPWR" Then
        BackupStack()
        X = SumPower(Stack(X_STACK_REG), Abs(Fix(Stack(Z_STACK_REG))), Abs(Fix(Stack(Y_STACK_REG))))
        Pop3()
        Stack(X_STACK_REG) = X
      ElseIf tok = "SUMNEGPWR" Then
        BackupStack()
        X = SumNegPower(Stack(X_STACK_REG), Abs(Fix(Stack(Z_STACK_REG))), Abs(Fix(Stack(Y_STACK_REG))))
        Pop3()
        Stack(X_STACK_REG) = X
      ElseIf tok = "SUMPWRTOL" Then
        BackupStack()
        X = SumPowerToler(Stack(X_STACK_REG), Stack(Z_STACK_REG), Abs(Fix(Stack(Y_STACK_REG))))
        Pop2()
        Stack(X_STACK_REG) = X
      ElseIf tok = "SUMNEGPWRTOL" Then
        BackupStack()
        X = SumNegPowerToler(Stack(X_STACK_REG), Stack(Z_STACK_REG), Abs(Fix(Stack(Y_STACK_REG))))
        Pop3()
        Stack(X_STACK_REG) = X
      Else
        sErrMessage = "Invalid SUM command"
      End If
    ElseIf tok.StartsWith("ZETA") Then
      If tok = "ZETA" Then
        BackupStack()
        X = Zeta(Stack(X_STACK_REG), Stack(Y_STACK_REG), 1)
        Pop2()
        Stack(X_STACK_REG) = X
      ElseIf tok = "ZETA2" Then
        BackupStack()
        X = Zeta(Stack(X_STACK_REG), Stack(Y_STACK_REG), Stack(Z_STACK_REG))
        Pop3()
        Stack(X_STACK_REG) = X
      End If
    ElseIf tok.IndexOf("_CDF") >= 0 Then
      If tok = "Q_CDF" Then
        BackupStack()
        Stack(X_STACK_REG) = Qcdf(Stack(X_STACK_REG))
      ElseIf tok = "T_CDF" Then
        BackupStack()
        Stack(X_STACK_REG) = T(Stack(X_STACK_REG), Fix(Stack(Y_STACK_REG)))
      ElseIf tok = "CHI_CDF" Then
        BackupStack()
        Stack(X_STACK_REG) = Chi(Stack(X_STACK_REG), Fix(Stack(Y_STACK_REG)))
      ElseIf tok = "F_CDF" Then
        BackupStack()
        Stack(X_STACK_REG) = Fcdf(Stack(X_STACK_REG), Fix(Stack(Z_STACK_REG)), Fix(Stack(Y_STACK_REG)))
      Else
        sErrMessage = "Undefined _CDF Function"
      End If
    ElseIf tok.IndexOf("_ICDF") >= 0 Then
      If tok = "Q_ICDF" Then
        BackupStack()
        Stack(X_STACK_REG) = QInv(Stack(X_STACK_REG))
      ElseIf tok = "T_ICDF" Then
        BackupStack()
        Stack(X_STACK_REG) = TInv(Stack(X_STACK_REG), Fix(Stack(Y_STACK_REG)))
      ElseIf tok = "CHI_ICDF" Then
        BackupStack()
        Stack(X_STACK_REG) = ChiInv(Stack(X_STACK_REG), Fix(Stack(Y_STACK_REG)))
      ElseIf tok = "F_ICDF" Then
        BackupStack()
        Stack(X_STACK_REG) = FInv(Stack(X_STACK_REG), Fix(Stack(Z_STACK_REG)), Fix(Stack(Y_STACK_REG)))
      Else
        sErrMessage = "Undefined _ICDF Function"
      End If
    ElseIf tok.IndexOf("_PDF") >= 0 Then
      If tok = "Q_PDF" Then
        BackupStack()
        Stack(X_STACK_REG) = Qpdf(Stack(X_STACK_REG), Stack(Y_STACK_REG), Stack(Z_STACK_REG))
      ElseIf tok = "T_PDF" Then
        BackupStack()
        Stack(X_STACK_REG) = Tpdf(Stack(X_STACK_REG), Fix(Stack(Y_STACK_REG)))
      ElseIf tok = "CHI_PDF" Then
        BackupStack()
        Stack(X_STACK_REG) = Chipdf(Stack(X_STACK_REG), Fix(Stack(Y_STACK_REG)))
      ElseIf tok = "F_PDF" Then
        BackupStack()
        Stack(X_STACK_REG) = Fpdf(Stack(X_STACK_REG), Fix(Stack(Z_STACK_REG)), Fix(Stack(Y_STACK_REG)))
      Else
        sErrMessage = "Undefined PDF Or inverse PDF Function"
      End If
    ElseIf tok = "Q_STD" Then
      BackupStack()
      Stack(X_STACK_REG) = QStd(Stack(X_STACK_REG))
    ElseIf tok.EndsWith("GAMMA") Then
      If tok = "GAMMA" Then
        fxGamma()
      ElseIf tok = "LNGAMMA" Then
        fxLnGamma()
      ElseIf tok = "IGAMMA" Then
        fxIncGamma()
      ElseIf tok = "IIGAMMA" Then
        fxInvIncGamma()
      End If
    ElseIf tok = "BETA" Then
      fxBeta()
    ElseIf tok = "MEMCOPY" Then
      MemCopy()
    ElseIf tok = "MEMSWAP" Then
      MemSwap()
    ElseIf tok = "BESSELJ0" Then
      fxBesselJ0()
    ElseIf tok = "BESSELJ1" Then
      fxBesselJ1()
    ElseIf tok = "BESSELJN" Then
      fxBesselJn()
    ElseIf tok = "BESSELY0" Then
      fxBessely0()
    ElseIf tok = "BESSELY1" Then
      fxBesselY1()
    ElseIf tok = "BESSELYN" Then
      fxBesselYn()
    ElseIf tok = "CHEBYSHEV" Then
      fxChebyshev()
    ElseIf tok = "HERMITE" Then
      fxHermite()
    ElseIf tok = "LEGENDRE" Then
      fxLegendre()
    ElseIf tok = "LAGUERRE" Then
      fxLaguerre()
    ElseIf tok = "CHEBYSHEV" Then
      fxChebyshev()
    ElseIf tok = "NEXTPRIME" Then
      fxNextPrime()
    ElseIf tok = "PREVPRIME" Then
      fxPrevPrime()
    ElseIf tok = "FIB" Then
      fxFibonacci()
    ElseIf tok = "R->P" Then
      fxRectToPolar()
    ElseIf tok = "P->R" Then
      fxPolarToRect()
    ElseIf tok = "D->R" Then
      BackupStack()
      Stack(X_STACK_REG) *= PI / 180
    ElseIf tok = "R->D" Then
      BackupStack()
      Stack(X_STACK_REG) *= 180 / PI
    ElseIf tok = "->HMS" Then
      fxToHMS()
    ElseIf tok = "HMS->" Then
      fxHMS()
    ElseIf tok = "HMS+" Then
      fxHMSAdd()
    ElseIf tok = "HMS-" Then
      fxHMSSub()
    ElseIf tok = "ERF" Then
      fxErf()
    ElseIf tok = "IERF" Then
      fxInvErf()
    ElseIf tok = "ERFC" Then
      fxErfc()
    ElseIf tok = "IERFC" Then
      fxInvErfc()
    ElseIf tok = "EXPOINTEG" Then
      fxExpoIntegral()
    ElseIf tok = "SI" Then
      fxSineIntegral()
    ElseIf tok.StartsWith("CI") Then
      If tok = "CI" Then
        fxCosineIntegral()
      ElseIf tok = "CISLOPE" Then
        SlopeCI(Stack(X_STACK_REG))
      ElseIf tok = "CIINTERCEPT" Then
        InterceptCI(Stack(X_STACK_REG))
      ElseIf tok = "CIYHAT" Then
        YhatCI(Stack(X_STACK_REG), Stack(Y_STACK_REG))
      ElseIf tok = "CIYHATFIT" Then
        YhatCIFitted(Stack(X_STACK_REG), Stack(Y_STACK_REG))
      ElseIf tok = "CIR2" Or tok = "CIRSQR" Then
        CIRsqr(Stack(X_STACK_REG))
      ElseIf tok = "CIR" Then
        CIR(Stack(X_STACK_REG))
      ElseIf tok = "CIMEANX" Then
        CIMeanX(Stack(X_STACK_REG))
      ElseIf tok = "CIMEANY" Then
        CIMeanY(Stack(X_STACK_REG))
      ElseIf tok = "CISDEVX" Then
        CISdevX(Stack(X_STACK_REG))
      ElseIf tok = "CISDEVY" Then
        CISdevY(Stack(X_STACK_REG))
      Else
        sErrMessage = "Invalid CI command"
      End If
    ElseIf tok = "COPYRIGHT" Then
      WriteLine(COPYRIGHT)
    ElseIf tok = "VERSION" Then
      WriteLine("Version {0}", VERSION)
    ElseIf tok.StartsWith("GET") Then
      If tok = "GETMAXMEM" Then
        Enter(MAX_MEM + 1)
      ElseIf tok = "GETNOW" Then
        Enter(GetDate)
        Enter(GetTime)
      ElseIf tok = "GETDATE" Then
        Enter(GetDate)
      ElseIf tok = "GETTIME" Then
        Enter(GetTime)
      ElseIf tok = "GETYEAR" Then
        dt = Now
        Enter(Year(dt))
      ElseIf tok = "GETMONTH" Then
        dt = Now
        Enter(Month(dt))
      ElseIf tok = "GETDAY" Then
        dt = Now
        Enter(Day(dt))
      ElseIf tok = "GETHR" Then
        dt = Now
        Enter(Hour(dt))
      ElseIf tok = "GETMIN" Then
        dt = Now
        Enter(Minute(dt))
      ElseIf tok = "GETSEC" Then
        dt = Now
        Enter(Second(dt))
      Else
        sErrMessage = "Invalid GET command"
      End If
    ElseIf tok = "EULER" Then
      ' Push Euler's constant in the stack
      Enter(0.57721566490153287)
    ElseIf tok.StartsWith("MFILL") Then
      If tok = "MFILL" Then
        fxMFill(Stack(X_STACK_REG), Stack(Y_STACK_REG))
      ElseIf tok = "MFILLRND" Then
        fxMFillRand(Stack(X_STACK_REG), Stack(Y_STACK_REG), Stack(Z_STACK_REG))
      ElseIf tok = "MFILLINTRND" Then
        fxMFillRandInt(Stack(X_STACK_REG), Fix(Stack(Y_STACK_REG)), Fix(Stack(Z_STACK_REG) + 1))
      ElseIf tok = "MFILLNORMRND" Then
        fxMFillNormRand(Stack(X_STACK_REG), Stack(Y_STACK_REG), Stack(Z_STACK_REG))
      ElseIf tok = "MFILLSEQ" Then
        fxMFillSeq(Stack(X_STACK_REG), Stack(Y_STACK_REG), Stack(Z_STACK_REG))
      Else
        sErrMessage = "Invalid MFILL command"
      End If
    ElseIf tok = "COPYSTACK" Then
      BackupStack()
    End If
  End Sub

  Private Function infinity(v As Double) As Boolean
    Throw New NotImplementedException()
  End Function

  Public Function Calc(ByVal S As String) As Double
    Dim tok, sErr, tokens() As String
    ' Preprocess input string by elemninating the spaces between the various STO and RcL
    ' commands and their associated indices. This action merges the STO and RCL commands
    ' with their indices, allowing the token parser to capture the STO and RCL commands
    ' as a single token. It later expracts the index associated with these memory
    ' access commands.
    S = S.ToUpper
    S = S.Replace("STO ", "STO")
    S = S.Replace("STO+ ", "STO+")
    S = S.Replace("STO- ", "STO-")
    S = S.Replace("STO* ", "STO*")
    S = S.Replace("STO/ ", "STO/")
    S = S.Replace("STOIND ", "STOIND")
    S = S.Replace("STOIND+ ", "STOIND+")
    S = S.Replace("STOIND- ", "STOIND-")
    S = S.Replace("STOIND* ", "STOIND*")
    S = S.Replace("STOIND/ ", "STOIND/")
    S = S.Replace("RCL ", "RCL")
    S = S.Replace("RCL+ ", "RCL+")
    S = S.Replace("RCL- ", "RCL-")
    S = S.Replace("RCL* ", "RCL*")
    S = S.Replace("RCL/ ", "RCL/")
    S = S.Replace("RCLIND ", "RCLIND")
    S = S.Replace("RCLIND+ ", "RCLIND+")
    S = S.Replace("RCLIND- ", "RCLIND-")
    S = S.Replace("RCLIND* ", "RCLIND*")
    S = S.Replace("RCLIND/ ", "RCLIND/")
    S = S.Replace("CLRDSP", "CLRDSP ") ' add a space which is deleted by the next statement
    S = S.Replace("DSP ", "DSP")
    S = S.Replace("FIX ", "FIX")
    S = S.Replace("SCI ", "SCI")
    ' split RPN expression into tokens
    tokens = S.Split(" ")
    ClearErrMessage()

    For Each tok In tokens
      ParseToken(tok)
      sErr = GetErrMessage()
      If sErr <> "" Then
        WriteLine("Runtime Error occured")
        WriteLine(sErr)
        Return 0
      End If
    Next
    Return Stack(X_STACK_REG)
  End Function

End Class

